<?php

if ( ! defined( 'ABSPATH' ) )   exit; 
/// registre admin menu
add_action('admin_menu', 'booking_desks_options_page');
function booking_desks_options_page()
{
    add_menu_page(
        'booking desks',
        'Booking Desks',
        'innova_manager_cap',
        'booking_desks',
        '',
        'dashicons-networking'

    );
}

function manage_desks_page()
{
    add_submenu_page(
        'booking_desks',
        'Manage Locations',
        'Manage Locations',
        'innova_manager_cap',
        'edit-tags.php?taxonomy=location',
        ''
    );
    add_submenu_page(
        'booking_desks',
        'Manage Buildings',
        'Manage Buildings',
        'innova_manager_cap',
        'edit-tags.php?taxonomy=buildings',
        ''
    );

    add_submenu_page(
        'booking_desks',
        'Manage Workspace Type',
        'Manage Workspace Type',
        'innova_manager_cap',
        'edit-tags.php?taxonomy=workspace-type',
    );

    add_submenu_page(
        'booking_desks',
        'Bookings',
        'Bookings',
        'public_data',
        'bookings',
        'booking_admin_interface'
    );

    add_submenu_page(
        'booking_desks',
        'Settings',
        'Settings',
        'innova_manager_cap',
        'booking_desks_settings',
        'booking_desks_settings_callback'
    );
    add_submenu_page(
        '',
        'Manage Offices Positions',
        'Manage Offices Positions',
        'innova_manager_cap',
        'offices-place',
        'build_affectation_space'
    );
    add_submenu_page(
        'booking_desks',
        'Cleaners Page',
        'Cleaner',
        'cleaner_cap',
        'cleaner',
        'cleaner_page_callback'
    );
}
add_action('admin_menu', 'manage_desks_page');

function build_affectation_space(){
    if (empty($_GET['plan']) || empty($_GET['building']))
        return;
    wp_enqueue_style('dragee-css', BOOKING_PLUGIN_URL . '/assets/style/dragee.css');
    wp_enqueue_style('jquery-ui-css', BOOKING_PLUGIN_URL . '/assets/style/libraries/jquery-ui.min.css');
    wp_enqueue_script('jquery-ui-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/jquery-ui.min.js');
    wp_enqueue_script('dragee-js', BOOKING_PLUGIN_URL . '/assets/javascripts/drag_drop.js');

    include(BOOKING_PLUGIN_DIR . '/admin/templates/manage_offices_place.php');

}

function booking_admin_interface()
{
    wp_enqueue_script('jquery-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/jquery.min.js');
    wp_enqueue_script('moment-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/moment.min.js');
    wp_enqueue_script('daterangepicker-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/daterangepicker.min.js');
    wp_enqueue_script('dragee-js', BOOKING_PLUGIN_URL . '/assets/javascripts/booking_page.js');
    wp_enqueue_style('daterangepicker-css', BOOKING_PLUGIN_URL . '/assets/style/libraries/daterangepicker.css');
    wp_enqueue_style('booking-page', BOOKING_PLUGIN_URL . '/assets/style/admin-booking-page.css');
    include(BOOKING_PLUGIN_DIR . '/admin/templates/bookings_page.php');
}
function booking_desks_settings_callback(){
    wp_enqueue_style('booking-page', BOOKING_PLUGIN_URL . '/assets/style/settings_page.css');
    include(BOOKING_PLUGIN_DIR . '/admin/templates/settings_page.php');
}
function cleaner_page_callback()
{
    wp_enqueue_script('moment-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/moment.min.js');
    wp_enqueue_script('daterangepicker-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/daterangepicker.min.js');
    wp_enqueue_script('cleaner-js', BOOKING_PLUGIN_URL . '/assets/javascripts/cleaner.js');  
    wp_enqueue_style('daterangepicker-css', BOOKING_PLUGIN_URL . '/assets/style/libraries/daterangepicker.css');
    wp_enqueue_style('cleaner-page', BOOKING_PLUGIN_URL . '/assets/style/cleaner.css');
    include(BOOKING_PLUGIN_DIR . '/admin/templates/cleaner.php');
}
/// registre post type
add_action('init', 'hooks_in_init', 0);


function hooks_in_init()
{   
    create_post_type_deks();
    bulding_taxonomie();
    create_tag_location_taxonomies();
    create_workspace_type_taxonomies();
    innov_save_desk_data(); 
}
function create_post_type_deks()
{
    $labels = array(
        'name'                  => 'Desks',
        'singular_name'         => 'Desk',
        'menu_name'             => 'Desks',
        'name_admin_bar'        => 'Desks',
        'add_new'               => 'Add New Desk',
        'add_new_item'          => 'Add New Desk',
        'new_item'              => 'New Desk',
        'edit_item'             => 'Edit Desk',
        'view_item'             => 'View Desk',
        'all_items'             => 'Manage Desks',
        'search items'          => 'Search Desk',
        'parent_item_colon'     => 'Parent Desk',
        'not_found'             => 'No Desk Found',
        'not_found_in_trash'    => 'No Desk Found In Trash',
    );

    $args = array(
        'labels'                => $labels,
        'show_in_rest' => true,
        'public'                => true,
        'publicly_queryable'   => true,
        'show_ui'               => true,
        'show_in_menu'          => 'booking_desks',
        'query_var'             => true,
        'rewrite'               => array('slug' => 'Desks'),
        'has_archive'           => true,
        'Hierarchical'          => false,
        'menu_position'         => null,
        'menu_icon'             => 'dashicons-format-image',
        'supports'              => array('title', 'author', 'thumbnail', 'excerpt', 'page-attributes'),
        'taxonomies'    => array('buildings', 'location','icon'),
        'capabilities'=> array(
            'edit_post' => 'edit_desk',
            'edit_posts' => 'edit_desks',
            'edit_others_posts' => 'edit_other_desks',
            'publish_posts' => 'publish_desks',
            'read_post' => 'read_desk',
            'read_private_posts' => 'read_private_desks',
            'delete_post' => 'delete_desk'
        )
    );
    register_post_type('desks', $args, 0);
}
////// registre taxonomie

function create_workspace_type_taxonomies(){

    $labels = array(
        'name'                       => 'Workspace type',
        'singular_name'              => 'Workspace type',
        'menu_name'                  => 'Workspace type',
        'all_items'                  => 'All Workspace type',
        'parent_item'                => 'Parent Workspace type',
        'parent_item_colon'          => 'Parent Workspace type',
        'new_item_name'              => 'Workspace type Name',
        'add_new_item'               => 'Add New Workspace type',
        'edit_item'                  => 'Edit Workspace type',
        'update_item'                => 'Update Workspace type',
        'separate_items_with_commas' => 'Separate Workspace type with commas',
        'search_items'               => 'Search Workspace type',
        'add_or_remove_items'        => 'Add or remove Workspace type',
        'choose_from_most_used'      => 'Choose from the most used Workspace type',
        'not_found'                  => 'Workspace type Not Found'
    );

    $args = array(
        'public' => true,
        'hierarchical' => false,
        'labels' => $labels,
        'show_in_rest' => true,
        'show_admin_column' => true,
        'show_ui' => true,
        'query_var' => true,
        'has_archive' => true,
        'hierarchical' => true,
        'rewrite' => array('slug' => 'workspace-type', 'hierarchical' => true),
        'capabilities' => array('manage_terms' => 'manage_terms',
                                'edit_terms' =>'manage_terms',
                                'delete_terms' =>'manage_terms',
                                'assign_terms' =>'manage_terms'
                        ),
        'meta_box_cb'     => 'wp_tax_build_metabox'
    );
    register_taxonomy('workspace-type', 'desks', $args);
}
function bulding_taxonomie()
{

    $labels = array(
        'name'                       => 'Buildings',
        'singular_name'              => 'Building',
        'menu_name'                  => 'Building',
        'all_items'                  => 'All Buildings',
        'parent_item'                => 'Parent Building',
        'parent_item_colon'          => 'Parent Building',
        'new_item_name'              => 'Building Name',
        'add_new_item'               => 'Add New Building',
        'edit_item'                  => 'Edit Building',
        'update_item'                => 'Update Building Type',
        'separate_items_with_commas' => 'Separate Building with commas',
        'search_items'               => 'Search Buildings',
        'add_or_remove_items'        => 'Add or remove Building Type',
        'choose_from_most_used'      => 'Choose from the most used Building',
        'not_found'                  => 'Building Not Found',
    );
    $args = array(
        'labels'                     => $labels,
        'show_in_rest'               => true,
        'public'                     => true,
        'show_admin_column'          => true,
        'show_in_menu'               => true,
        // 'hierarchical'               => true,
        'capabilities' => array('manage_terms' => 'manage_terms',
                                'edit_terms' =>'manage_terms',
                                'delete_terms' =>'manage_terms',
                                'assign_terms' =>'manage_terms'
                                ),
        'meta_box_cb'                 => 'wp_buildings_metabox'
        // 'show_tagcloud'=>true


    );
    register_taxonomy('buildings', 'desks', $args);
}

//Callback to set up the metabox
function wp_buildings_metabox($post)
{
    //Get taxonomy and terms
    $taxonomy = 'buildings';
    $post_id = !empty($post->ID) ? $post->ID : '';
    $id_city = get_the_terms($post_id, 'location');
    $id_city = (!empty($id_city) && !is_wp_error($id_city) && $id_city) ? $id_city[0]->term_id : '';
    if(isset($_POST['action']) &&  $_POST['action'] == 'get_building_in_specifique_city'){
        define('DOING_AJAX', true);
        $id_city = !empty($_POST['id_city']) ? $_POST['id_city'] : $id_city ;
        $id_post = $_POST['id_post'];
        $terms = get_building_in_specifique_city($id_city,$taxonomy);

        build_right_bloc_option($terms,$taxonomy,$id_post);
        die;
    }
    if(empty($post)){
        return;
    }
    $terms = get_terms($taxonomy,
                     array('hide_empty' => 0,
                            'parent' => 0,
                            'meta_query' => array(
                                array(
                                   'key'       => 'city_of_building',
                                   'value'     => $id_city,
                                   'compare'   => '='
                                )
                           )
                    ));
    build_right_bloc_option($terms,$taxonomy,$post->ID);
}

function build_right_bloc_option($terms,$taxonomy,$post_id){
    if(empty($terms)){
        echo "<div class='categorydiv building-container-right'>no building in this city</div>";
        return ;
    }
    ob_start();
    //Set up the taxonomy object and get terms
    $tax = get_taxonomy($taxonomy);
    $name = 'tax_input[' . $taxonomy . ']';
    //Get current and popular terms
    $popular = get_terms($taxonomy, array('orderby' => 'count', 'order' => 'DESC', 'number' => 10, 'hierarchical' => false));
    $postterms = get_the_terms($post_id, $taxonomy);
    $current = ($postterms ? array_pop($postterms) : false);
    $current = ($current ? $current->term_id : 0);
?>
    <div id="taxonomy-<?php echo $taxonomy; ?>" class="categorydiv building-container-right">

        <!-- Display tabs-->
        <ul id="<?php echo $taxonomy; ?>-tabs" class="category-tabs">
            <li class="tabs"><a href="#<?php echo $taxonomy; ?>-all" tabindex="3"><?php echo $tax->labels->all_items; ?></a></li>
            <li class="hide-if-no-js"><a href="#<?php echo $taxonomy; ?>-pop" tabindex="3"><?php _e('Most Used'); ?></a></li>
        </ul>

        <!-- Display taxonomy terms -->
        <div id="<?php echo $taxonomy; ?>-all" class="tabs-panel">
            <ul id="<?php echo $taxonomy; ?>checklist" class="list:<?php echo $taxonomy ?> categorychecklist form-no-clear">
                <?php foreach ($terms as $term) {
                    $id = $taxonomy . '-' . $term->term_id;
                    echo "<li id='$id'><label class='selectit'>
                                <input type='radio' id='in-$id'
                                    name='{$name}'" . checked($term->term_id,$current, false) .
                                    "data-id='$term->term_id' data-post='$post_id' value='$term->name'/>$term->name<br />
                        </label></li>";
                } ?>
            </ul>
        </div>

        <!-- Display popular taxonomy terms -->
        <div id="<?php echo $taxonomy; ?>-pop" class="tabs-panel" style="display: none;">
            <ul id="<?php echo $taxonomy; ?>checklist-pop" class="categorychecklist form-no-clear">
                <?php foreach ($popular as $term) {
                    $id = 'popular-' . $taxonomy . '-' . $term->term_id;
                    echo "<li id='$id'><label class='selectit'>";
                    echo "<input type='radio' id='in-$id'" . checked($current, $term->term_id, false) . "value='$term->term_id' />$term->name<br />";
                    echo "</label></li>";
                } ?>
            </ul>
        </div>

    </div>
<?php
    $html = ob_get_contents();
    ob_end_clean();
    echo $html;
}

//create two taxonomies, genres and tags for the post type "tag"
function create_tag_location_taxonomies()
{

    // Add new taxonomy, NOT hierarchical (like tags)
    $labels = array(
        'name' => _x('Locations', 'taxonomy general name'),
        'singular_name' => _x('Location', 'taxonomy singular name'),
        'search_items' =>  __('Search Locations'),
        'popular_items' => __('Popular Locations'),
        'all_items' => __('All Locations'),
        'parent_item' => null,
        'parent_item_colon' => null,
        'edit_item' => __('Edit Location'),
        'update_item' => __('Update Location'),
        'add_new_item' => __('Add New Location'),
        'new_item_name' => __('New Location Name'),
        'separate_items_with_commas' => __('Separate Locations with commas'),
        'add_or_remove_items' => __('Add or remove Locations'),
        'choose_from_most_used' => __('Choose from the most used Locations'),
        'menu_name' => __('Locations'),
    );

    register_taxonomy('location', 'desks', array(
        'hierarchical' => false,
        'labels' => $labels,
        'show_in_rest' => true,
        'show_admin_column' => true,
        'show_ui' => true,
        'update_count_callback' => '_update_post_term_count',
        'query_var' => true,
        'has_archive' => true,
        'rewrite' => array('slug' => 'location'),
        'capabilities' => array('manage_terms' => 'manage_terms',
                                'edit_terms' =>'manage_terms',
                                'delete_terms' =>'manage_terms',
                                'assign_terms' =>'manage_terms'
                        ),
        'meta_box_cb'     => 'wp_tax_build_metabox'

    ));
}
//Callback to set up the metabox
function wp_tax_build_metabox($post,$param)
{
    //Get taxonomy and terms
    $taxonomy = $param['args']['taxonomy'];

    //Set up the taxonomy object and get terms
    $tax = get_taxonomy($taxonomy);
    $terms = get_terms($taxonomy, array('hide_empty' => 0));

    //Name of the form
    $name = 'tax_input[' . $taxonomy . ']';

    //Get current and popular terms
    $popular = get_terms($taxonomy, array('orderby' => 'count', 'order' => 'DESC', 'number' => 10, 'hierarchical' => false));
    $postterms = get_the_terms($post->ID, $taxonomy);
    $current = ($postterms ? array_pop($postterms) : false);
    $current = ($current ? $current->term_id : 0);
    ?>
    <div id="taxonomy-<?php echo $taxonomy; ?>" class="categorydiv">

        <!-- Display tabs-->
        <ul id="<?php echo $taxonomy; ?>-tabs" class="category-tabs">
            <li class="tabs"><a href="#<?php echo $taxonomy; ?>-all" tabindex="3"><?php echo $tax->labels->all_items; ?></a></li>
            <li class="hide-if-no-js"><a href="#<?php echo $taxonomy; ?>-pop" tabindex="3"><?php _e('Most Used'); ?></a></li>
        </ul>

        <!-- Display taxonomy terms -->
        <div id="<?php echo $taxonomy; ?>-all" class="tabs-panel">
            <ul id="<?php echo $taxonomy; ?>checklist" class="list:<?php echo $taxonomy ?> categorychecklist form-no-clear">
                <?php foreach ($terms as $term) {
                    $id = $taxonomy . '-' . $term->term_id;
                    echo "<li id='$id'><label class='selectit'>";
                    echo "<input type='radio' id='in-$id' name='{$name}'" . checked($current, $term->term_id, false) . " class = '".$taxonomy."-tax' data-post='$post->ID' data-id='$term->term_id' value='$term->name' data-parent=" . $term->name . " />$term->name<br />";
                    echo "</label></li>";
                } ?>
            </ul>
        </div>

        <!-- Display popular taxonomy terms -->
        <div id="<?php echo $taxonomy; ?>-pop" class="tabs-panel" style="display: none;">
            <ul id="<?php echo $taxonomy; ?>checklist-pop" class="categorychecklist form-no-clear">
                <?php foreach ($popular as $term) {
                    $id = 'popular-' . $taxonomy . '-' . $term->term_id;
                    echo "<li id='$id'><label class='selectit'>";
                    echo "<input type='radio' id='in-$id'" . checked($current, $term->term_id, false) . "value='$term->term_id' />$term->name<br />";
                    echo "</label></li>";
                } ?>
            </ul>
        </div>

    </div>
<?php
}

add_action('init','wp_buildings_metabox');

function innov_save_desk_data() {
    if(!empty($_POST['action']) && !empty($_POST['nonce']) && $_POST['action'] == 'save-details-desks' && wp_verify_nonce($_POST['nonce'],'save-details-desks-'.BOOKING_PLUGIN_DIR)){
        
        $desk_id = is_numeric($_POST['desk_id']) ? $_POST['desk_id'] : '' ;
        if( !empty($_POST['action_type']) && $_POST['action_type'] == 'remove' ){
           $__res= delete_desk_meta(null,$_POST['desk_id']);
            echo $__res;
            die;
        }
        $capacity = is_numeric($_POST['capacity']) ? $_POST['capacity'] : '' ;
        $desk_id = is_numeric($_POST['desk_id']) ? $_POST['desk_id'] : '' ;
        $price = is_numeric($_POST['price']) ? $_POST['price'] : '' ;
        $room = is_numeric($_POST['room']) ? $_POST['room'] : '' ;
        $seat = is_numeric($_POST['seat']) ? $_POST['seat'] : '' ;
        $desk_details = array('price'=>$price,'room'=>$room,'seat'=>$seat);
        	$res = update_post_meta(
        		$desk_id,
        		'_desk_details',
        		$desk_details
        	);
            $res_cap = update_post_meta(
        		$desk_id,
        		'_max_people',
        		$capacity
        	);
            update_post_meta(
        		$desk_id,
        		'_room',
        		$room
        	);
        echo ($res_cap || $res);
        die;
    }
}

function register_desks_image_meta() {
    register_meta('post', '_desks_image', array(
        'object_subtype' => 'desks',
        'type'           => 'string',
        'description'    => 'Optional image for Desks post type',
        'single'         => true,
        'show_in_rest'   => false, 
    ));
}
add_action('init', 'register_desks_image_meta');

function add_desks_image_meta_box() {
    add_meta_box(
        'desks_image_meta_box',
        'Optional Image',
        'render_desks_image_meta_box',
        'desks',
        'side',
        'low'
    );
}
add_action('add_meta_boxes', 'add_desks_image_meta_box');

function render_desks_image_meta_box($post) {
    // Retrieve the existing image ID from the post meta
    $image_id = get_post_meta($post->ID, '_desks_image', true);
    ?>
    <div>
        <input type="hidden" id="desks_image" name="desks_image" value="<?php echo esc_attr($image_id); ?>" />
        <input type="button" id="desks_image_upload_button" class="button" value="Upload Image" />
        <input type="button" id="desks_image_remove_button" class="button" value="Remove Image" />
    </div>
    <div id="desks_image_preview">
        <?php if ($image_id): 
                $icon_src = wp_get_attachment_url($image_id);
                if (pathinfo($icon_src, PATHINFO_EXTENSION) === 'svg') {
                    echo file_get_contents($icon_src);
                } else {
                    echo '<img src="' . $icon_src . '"></div>';
                }
            endif;
        ?>
    </div>

    <script>
        jQuery(document).ready(function($){
            var frame;
            $('#desks_image_upload_button').on('click', function(e) {
                e.preventDefault();
                if (frame) {
                    frame.open();
                    return;
                }
                frame = wp.media({
                    title: 'Select or Upload Image',
                    button: {
                        text: 'Use this image'
                    },
                    multiple: false
                });

                frame.on('select', function() {
                    var attachment = frame.state().get('selection').first().toJSON();
                    $('#desks_image').val(attachment.id);
                    console.log(attachment);
                    $('#desks_image_preview').html('<img src="' + attachment.url + '" />');
                });

                frame.open();
            });

            $('#desks_image_remove_button').on('click', function() {
                $('#desks_image').val('');
                $('#desks_image_preview').html('');
            });
        });
    </script>
    <?php
}

function save_desks_image_meta($post_id) {

    error_log('1111');

    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
        return $post_id;
    }

    error_log('222');

    // Update the meta field.
    $image_id = isset($_POST['desks_image']) ? intval($_POST['desks_image']) : '';
    error_log( $image_id);

    update_post_meta($post_id, '_desks_image', $image_id);
}
add_action('save_post', 'save_desks_image_meta');


/**
 * Removes the width and height attributes of <img> tags for SVG
 * 
 * Without this filter, the width and height are set to "1" since
 * WordPress core can't seem to figure out an SVG file's dimensions.
 * 
 * For SVG:s, returns an array with file url, width and height set 
 * to null, and false for 'is_intermediate'.
 * 
 * @wp-hook image_downsize
 * @param mixed $out Value to be filtered
 * @param int $id Attachment ID for image.
 * @return bool|array False if not in admin or not SVG. Array otherwise.
 */
function wpse240579_fix_svg_size_attributes( $out, $id ) {
    $image_url  = wp_get_attachment_url( $id );
    $file_ext   = pathinfo( $image_url, PATHINFO_EXTENSION );

    if ( is_admin() || 'svg' !== $file_ext ) {
        return false;
    }

    return array( $image_url, null, null, false );
}
add_filter( 'image_downsize', 'wpse240579_fix_svg_size_attributes', 10, 2 ); 
