<?php
if ( ! defined( 'ABSPATH' ) )   exit; 

class Activation_booking_desks{
    function __construct() {
        update_option('plugin_permalinks_flushed', 0);
    }
    public function create_booking_desks_database_table() {
        global $wpdb;
        $queries=[];
        $tables_name = array(
                            array('table_name'=>'client_info',
                                    'columns'=> array(
                                    "  client_id int NOT NULL AUTO_INCREMENT, ",
                                    "  first_name varchar(50) NULL, ",
                                    "  last_name varchar(50) NULL, ",
                                    "  phone_number varchar(50) NULL, ",
                                    "  email varchar(50) NULL, ",
                                    "  city varchar(50) NULL, ",
                                    "  PRIMARY KEY (client_id), ",
                                    "  user_ID int NULL ",
                                )
                            ),
                            array('table_name'=>'booking_info',
                                 'columns'=> array(
                                    "   booking_id int NOT NULL AUTO_INCREMENT , ",
                                    "   client_id int NULL, ",
                                    "   cleaner_id bigint UNSIGNED NULL, ",
                                    "   desk_id int NOT NULL, ",
                                    "   seat int NOT NULL, ",
                                    "   room int NOT NULL, ",
                                    "   floor varchar(50) NULL, ",
                                    "   desk_type varchar(50) NULL, ",
                                    "   date_start datetime NOT NULL, ",
                                    "   date_end datetime NOT NULL, ",
                                    "   is_paid varchar(50)  NULL, ",
                                    "   order_id int NOT NULL, ",
                                    "   pass_code int NOT NULL, ",
                                    "   booking_type varchar(50) NULL, ",
                                    "   PRIMARY KEY (booking_id), ",
                                    "   FOREIGN KEY (client_id) REFERENCES ". $wpdb->prefix ."client_info(client_id),  ",
                                    "   FOREIGN KEY (cleaner_id) REFERENCES ". $wpdb->prefix ."users(ID)  "
                                )
                            ),
                        );
        require_once( ABSPATH . '/wp-admin/includes/upgrade.php' );
        foreach ($tables_name as $table) {
            $wp_track_table = $wpdb->prefix . $table['table_name'];
            $sql = "CREATE TABLE IF NOT EXISTS $wp_track_table ( ";
            foreach($table['columns'] as $column){
                $sql .= $column;
            }
            $sql .= "); ";
            dbDelta($sql);
        }  
      }
    public function create_plugin_roles(){
            $roles = array('booking-member'=>'Booking member','innova-manager'=>'Innova rooms Manager','cleaner'=>'Cleaner');
            $role_adm = get_role( 'administrator');
            $role_adm->add_cap( 'public_data');
            $role_adm->add_cap( 'manage_woocommerce_coupons');
            foreach ($roles as $slug => $name) {
                $role = add_role( $slug, $name,get_role('subscriber')->capabilities );
                if(empty($role)) continue;
                if( $slug == 'booking-member' ){
                    $role->add_cap( 'public_data' );
                }
                elseif( $slug == 'innova-manager' ){
                    $psts=['desk','shop_coupon'];
                    foreach ( $psts as $pst ) {
                        $role->add_cap( 'read_'.$pst );
                        $role->add_cap( 'edit_'.$pst );
                        $role->add_cap( 'edit_'.$pst.'s' );
                        $role->add_cap( 'edit_other_'.$pst.'s' );
                        $role->add_cap( 'edit_published_'.$pst.'s' );
                        $role->add_cap( 'publish_'.$pst.'s' );
                        $role->add_cap( 'read_private_'.$pst.'s' );
                        $role->add_cap( 'delete_'.$pst );
                    }
                    $role->add_cap( 'innova_manager_cap' );
                    $role->add_cap( 'cleaner_cap' );
                    $role->add_cap('upload_files');
                    $role->add_cap( 'edit_posts');
                    $role->add_cap('public_data');
                    $role->add_cap('manage_terms');
                    $role->add_cap('manage_woocommerce_coupons');
                    $role_adm->add_cap( 'innova_manager_cap' );
                }
                elseif( $slug == 'cleaner' ){
                    $role->add_cap( 'cleaner_cap' );
                    $role_adm->add_cap( 'cleaner_cap' );
                }
            }
      }    
}
$activation =new Activation_booking_desks();

register_activation_hook( BOOKING_FILE, array(&$activation,'create_booking_desks_database_table') );
register_activation_hook( BOOKING_FILE, array(&$activation,'create_plugin_roles') );


