<?php



$location = $_GET['rooms-location'] ?? 0;

$building = 0;

if(isset($_GET['rooms-building'])){

    $_building = json_decode(stripslashes($_GET['rooms-building']));

    $building =  isset($_building->id) ? $_building->id : 0;

}

$floor = $_GET['rooms-floor'] ?? 0;

$start_time = $_GET['start-time'] ?? 0;

$end_time = $_GET['end-time'] ?? 0;


if(  wp_verify_nonce($_GET['building_for_city'], BOOKING_DIRNAME)){
    $error=[];

    if( $location && is_numeric($location) && $building && is_numeric($building)  &&

    $floor ){

        if( $end_time <= $start_time ) $error[]='End time should be grater than Start time';

        $date_start = prase_time_to_date_Time($start_time);

        $date_end = prase_time_to_date_Time($end_time);

        if(!check_date_input($date_start) || !check_date_input($date_end) ) $error[]='time format incorect';

        $sanitized_floor = sanitize_text_field($floor);

        $pos = strpos($floor,'ground');

        $floor = ($pos || $pos === 0) ? str_replace(' ','-',$sanitized_floor) : 

                str_replace('st floor','st-floor',sanitize_text_field($sanitized_floor));

        $rooms = get_term_meta($building,'rooms_count',true);

        if(empty($rooms[$floor])) 

            $error[]='please fill the number of rooms you have in the floor <a target="_blank" href="'.admin_url('term.php?taxonomy=buildings&tag_ID='.$building).'"> Here </a>';

        if(empty($error)){

            $sanitized_floor = return_ordinal_number(get_floor_from_string($sanitized_floor)).' Floor';

            $reserved_office = get_reserved_offices($date_start,$date_end,true,array('floor'=>$sanitized_floor));

            $reserved_office = empty($reserved_office) ? [] : $reserved_office ;

            $countrooms = $rooms[$floor];

        }

    }

    else  

    $error[] = 'all fields are required';

    // booking_set_error('errors_in_admin_area_edit_posts','all fields are required');

}

$locations = get_terms('location', array('hide_empty' => 0));

$is_response = !empty($countrooms);



?>

<div class="main-panel">

    <form method="GET" class="f-manag-r">



        <table class="table_manage_rooms">



            <tr>

                <td><label for="rooms-location"> Location :</label></td>

                <td>

                    <select class="rooms-location" name="rooms-location" required>

                        <option value="0">choose location</option>

                        <?php if (!empty($locations)) :

                            $opts = '';

                            foreach ($locations as $loca) {
                                if($is_response){
                                    $opts .= ' <option value="' . $loca->term_id . '" ' . ($loca->term_id == $location ? 'selected' : '') . '>'   . $loca->name . '</option>';
                                    continue;
                                }
                                 $opts .= ' <option value="' . $loca->term_id . '" >'

                                    . $loca->name . '</option>';

                            }

                            echo $opts;

                        ?>

                        <?php endif; ?>

                    </select>

                </td>

                <?php

                if ($is_response) {

                    $_building_data = ['id' => $_building->id, 'name' => $_building->name];

                    $_building_data = htmlspecialchars(json_encode($_building_data), ENT_QUOTES, 'UTF-8');

                ?>



                    <td class="dv-building"><label for="rooms-building"> Building :</label></td>

                    <td class="dv-building">

                        <select class="rooms-building" name="rooms-building" required>

                            <option value="<?php echo $_building_data; ?>" selected><?php echo $_building->name; ?></option>;

                        </select>

                    </td>



                    <td class="dv-floor"><label for="rooms-floor"> Floor :</label></td>

                    <td class="dv-floor">

                        <select class="floor-floor" name="rooms-floor" required>

                            <option value="<?php echo $floor; ?>" selected><?php echo $floor; ?></option>;

                        </select>

                    </td>

                    <td class="dv-room"><label class="fonts12 full-inputW wrapper-label-right"> start time </label></td>

                    <td class="dv-room">

                        <input type="text" name="start-time" class="full-day-rate form-control cleaner-time" value="<?php echo $start_time; ?>" required>

                    </td>



                    <td class="dv-room"><label class="fonts12 full-inputW wrapper-label-right"> end time </label></td>

                    <td class="dv-room">

                        <input type="text" name="end-time" class="full-day-rate form-control cleaner-time" value="<?php echo $end_time; ?>" required>

                    </td>

                <?php

                } else {

                ?>

                    <td class="dv-building hide"><label for="rooms-building"> Building :</label></td>

                    <td class="dv-building hide">

                        <select class="rooms-building" name="rooms-building" required>

                            <option value="0">select building</option>

                        </select>

                    </td>

                    <td class="dv-floor hide"><label for="rooms-floor"> Floor :</label></td>

                    <td class="dv-floor hide">

                        <select class="floor-floor" name="rooms-floor" required>

                            <option value="0">choose floor</option>

                        </select>

                    </td>

                    <td class="dv-room hide"><label class="fonts12 full-inputW wrapper-label-right"> start time </label></td>

                    <td class="dv-room hide"><input type="text" name="start-time" class="full-day-rate form-control cleaner-time" required></td>



                    <td class="dv-room hide"><label class="fonts12 full-inputW wrapper-label-right"> end time </label></td>

                    <td class="dv-room hide"><input type="text" name="end-time" class="full-day-rate form-control cleaner-time" required></td>

                <?php

                }

                ?>

            </tr>

            <tr>

                <td>

                    <input type="hidden" value="<?php echo $_GET["page"]; ?>" name="page">

                    <input type="submit" name="submitbtn_find_vacated_room" id="submitbtn_vacated_room" value='Find Vacated Room' class="btn-chang-layout">

                    <?php wp_nonce_field(BOOKING_DIRNAME, 'building_for_city');  ?>

                </td>

            </tr>

            <?php

            if (!empty($error)) {

                $_html = '<tr class="errors"><td><h4>Error : </h4>

                    <div>';

                foreach ($error as $err) {

                    $_html .= '<p>' . $err . '</p>';

                }

                $_html .=  '</div></td></tr>';

                echo $_html;

            }

            ?>



        </table>







    </form>

</div>

<?php if ($is_response) :

    $btn_text = 'Reserve to clean';

    if ($is_administrator) {

        $btn_text = 'Affect to cleaner';

        $cleaners_html = get_cleaners(true);

    }

?>



    <div class='displying-title'>

        <h3> Vacated Rooms</h3>

        <table class='locked-rooms'>

            <thead class="thead-orange">

                <tr>

                    <th>Location</th>

                    <th>Building</th>

                    <th>Floor</th>

                    <th>Room</th>

                    <?php

                    if ($is_administrator)

                        echo '<th>Cleaners</th>';

                    ?>

                    <th>Actions</th>

                    <th>Last scheduled clean up</th>

                    <th>Room state</th>

                </tr>

            </thead>

            <?php

            $current_time = new DateTime();

            for ($i = 1; $i <= $countrooms; $i++) {



                if (!empty($reserved_office)) {

                    $offices = get_posts(array(

                        'post_type' => 'desks',

                        'post__in' => $reserved_office,

                        'tax_query' => array(

                            'relation' => 'AND',

                            array(

                                'taxonomy' => 'location',

                                'field'    => 'term_id',

                                'terms'    => $location

                            ),

                            array(

                                'taxonomy' => 'buildings',

                                'field'    => 'term_id',

                                'terms'    => $building

                            )

                        ),

                        'meta_query' => array(

                            array(

                                'key'   => '_room',

                                'value' => $i,

                            )

                        )

                    ));

                }



                if (!empty($offices)) continue;

                $city = get_term_by('id', $location, 'location');

                $city = $city->name ?? '';

                $room = $i ?? '';

                $last_cleaning_date = get_last_cleaning_date($location, $building, $floor, $room) ?? [];

                $html_last_cleaning_date = 'no cleaning yet.';

                if(!empty($last_cleaning_date)){

                    $html_last_cleaning_date = '<ul>';

                    $html_last_cleaning_date .= implode('', array_map(fn($date) => "<li>{$date['date_end']}</li>", $last_cleaning_date));

                    $html_last_cleaning_date .= '</ul>';

                }

                $is_the_time_to_clean = check_the_time_to_clean($last_cleaning_date); 

            ?>

                <tr class="tr-room-<?php echo $room; ?>">

                    <td><?php echo $city; ?></td>

                    <td><?php echo $_building->name; ?></td>

                    <td><?php echo $floor; ?></td>

                    <td><?php echo $room; ?></td>

                    <?php

                    if ($is_administrator)

                        echo '<td>' . $cleaners_html['html'] . '</td>';

                    ?>

                    <td>

                        <button class="action-btn cleaning-btn" data-location="<?php echo $location; ?>" data-building="<?php echo $building; ?>" data-floor="<?php echo $floor; ?>" data-time-start="<?php echo $start_time; ?>" data-time-end="<?php echo $end_time; ?>" data-room-numbre="<?php echo $room; ?>" <?php echo $is_the_time_to_clean ? '' : 'disabled' ?>>

                            <?php

                            echo $btn_text;

                            ?>

                        </button>

                    </td>

                    <td><?php echo $html_last_cleaning_date; ?></td>



                    <td class="room-state">---</td>

                </tr>

            <?php } ?>

        </table>

    </div>

<?php endif; ?>