<?php
if ( ! defined( 'ABSPATH' ) )   exit;    

$current_user = wp_get_current_user();
$sql_part ='';
$error= [];
$search_text ='';
$filter_customer = isset($_GET['customer']) ? sanitize_text_field($_GET['customer']) : '';
$filter_building = isset($_GET['building']) ? sanitize_text_field($_GET['building']) : '';
$filter_floor = isset($_GET['floor']) ? sanitize_text_field($_GET['floor']) : '';
$filter_desk_type = isset($_GET['desk-type']) ? sanitize_text_field($_GET['desk-type']) : '';
$filter_date = isset($_GET['date']) ? sanitize_text_field($_GET['date']) : '';

if($current_user && in_array('booking-member',$current_user->roles)){
    $sql_part = 'and ci.user_ID = '.$current_user->ID;
}
global $wpdb;

$query = "SELECT * FROM {$wpdb->prefix}client_info ci JOIN {$wpdb->prefix}booking_info bi on ci.client_id = bi.client_id where 1 = 1 $sql_part";


if (!empty($filter_customer)) {
  $query .= " AND (ci.first_name LIKE '%$filter_customer%' OR ci.last_name LIKE '%$filter_customer%')";
  $search_text .= ' Customer:'.$filter_customer;
}

if (!empty($filter_building)) {
    $offices_id = get_posts(array(
                    'post_type' => 'desks', 
                    'posts_per_page' => -1, 
                    'fields' => 'ids',
                    'tax_query' => array(
                        array(
                            'taxonomy' => 'buildings',
                            'field' => 'term_id',
                            'terms' => $filter_building,
                        ),
                    ),
                ));
    
    if(empty($offices_id))
        $offices_id = array(0);
    $building_list =implode("','", array_map('sanitize_text_field', $offices_id));
    $query .= " AND bi.desk_id in ('$building_list')";
}

if (!empty($filter_floor)) {
  $query .= " AND bi.floor = '$filter_floor'";
  $search_text .= ' floor:'.$filter_floor; 

}

if (!empty($filter_desk_type)) {
  $query .= " AND bi.desk_type LIKE '%$filter_desk_type%'";
  $search_text .= ' Desk type:'.$filter_desk_type; 

}

if (!empty($filter_date)) {

  $dates = str_replace(' - ','-',$filter_date); 
  $dates = explode('-',$dates);
  $date_start = adapte_the_date_format($dates[0],'Y-m-d');
  $date_end =  adapte_the_date_format($dates[1],'Y-m-d');
  if( !empty($date_start) && !empty($date_end) ){
    $dates_time = prase_date_to_date_Time($date_start,$date_end);
    $date_start =$dates_time[0];
    $date_end =$dates_time[1];
    if($date_start < $date_end){
      $query .= " AND bi.date_start >= '$date_start' AND bi.date_end <= '$date_end'";
      $search_text .= ' Date between '.$date_start.' and '.$date_end ; 
    }
    else
      $error['date'][] = 'Date start is greater than date end';
  }
  else
    $error['date'][] = 'Incorrect date';
}


$query .= 'order by booking_id desc ';
$results =  $wpdb->get_results($query);
$_count_result = count($results);
$all_building = get_terms(array(
                                'taxonomy' => 'buildings',
                                'hide_empty' => false
                              ));                              
$_option_building = '<option value="0"> Select building </option>';
if(!empty($all_building)){
    if(!empty($filter_building)){
        $spec_term =array_values( array_filter($all_building,function($item) use ($filter_building){
                                    return  $item->term_id == $filter_building ;
                                }));
      $search_text .= ' Building:'.$spec_term[0]->name; 
    }
    foreach ($all_building as $building) {
      $_option_building .= '<option value="'.$building->term_id.'"   '. ($filter_building == $building->term_id  ? "selected" : "").'              >'.$building->name.'</option>';
    }
}

  $workspace_type = get_terms(array(
    'taxonomy' => 'workspace-type',
    'hide_empty' => false
  ));

  $_option_workspace_type = '<option value="0"> Select office type </option>';
  if(!empty($workspace_type))
    foreach ($workspace_type as $type) {
      $_option_workspace_type .= '<option value="'.$type->name.'"   '. ($filter_desk_type == $type->name  ? "selected" : "").' >'.$type->name.'</option>';
    }
?>

<h1>Booking Overview</h1>

<h3> <?php echo $_count_result.' results for : '.$search_text; ?></h3>
<form method="GET" class="filter-form">
  <div class="container-customer-filter">
      <label for="customer">Customer:</label>
      <input type="text" name="customer" id="customer" value="<?php echo esc_attr($filter_customer); ?>">
      <div class="container-result-search"></div>
  </div>
  <label for="building">Building:</label>
  <select name="building" id="building">
          <?php
            echo $_option_building;
          ?>
  </select>

  <label for="floor">Floor:</label>
  <select name="floor" id="floor">
        <option value="0"> Select floor </option>
        <option value="Ground Floor" <?php echo $filter_floor == 'Ground Floor' ? 'selected' : '';  ?> > Ground floor </option> 
        <option value="First Floor" <?php echo $filter_floor == 'First Floor' ? 'selected' : '';  ?> > First floor </option> 
        <option value="Second Floor" <?php echo $filter_floor == 'Second Floor' ? 'selected' : '';  ?> > Second floor </option>
        <option value="Third Floor" <?php echo $filter_floor == 'Third Floor' ? 'selected' : '';  ?> > Third floor </option>
        <option value="Fourth Floor" <?php echo $filter_floor == 'Fourth Floor' ? 'selected' : '';  ?> > Fourth floor </option>
        <option value="Fifth Floor" <?php echo $filter_floor == 'Fifth Floor' ? 'selected' : '';  ?> > Fifth floor </option>
  </select>

  <label for="desk">Desk type:</label>
  <select name="desk-type" id="desk-type">
          <?php
            echo $_option_workspace_type;
          ?>
  </select>

  <label for="date">Date:</label>
  <input type="text" name="date" id="filter-booking-date" value="<?php echo esc_attr($filter_date); ?>">
  <input type="hidden" name="page" value="bookings">
  <?php 
    echo wp_nonce_field(BOOKING_DIRNAME,'_nonce_keyword');
  ?>
  <button type="submit">Filter</button>
</form>

<table class="table_booking_verview merged-table">
  <thead class="thead-orange">
    <tr>
      <th>Clients info</th>
      <th>offices details</th>
      <th>Reservations dates</th>
      <th>Order details</th>
    </tr>
  </thead>
  <tbody>
<?php
if(!empty($results)){
  $i = 0;
 
  foreach ($results as $row) {
    $i++;
      $building = get_the_terms($row->desk_id,'buildings');
      $location = get_the_terms($row->desk_id,'location');
      $desk = get_post($row->desk_id,'post_name');
      $order_link = get_edit_post_link($row->order_id);
      $order_created_date = get_post_field( 'post_date', $row->order_id );
      $total_price = get_post_meta($row->order_id, '_order_total', true);
      $order_tax = get_post_meta($row->order_id, '_order_tax', true);
      
      $class = '';
      if($results[$i]->order_id == $row->order_id)
          $class = 'merged-row'; 
      $check_class = (isset($results[$i-2]) && $results[$i-2]->order_id != $row->order_id) || ( $i-1 == 0) ;
      ?>
      <tr class="<?php echo $class ; ?>" >
        <td>
          <span class="costum-td-details">  <?php echo  $check_class ? '- Name : '.$row->first_name .' '.$row->last_name : ''; ?></span>
          <span class="costum-td-details">  <?php echo  $check_class ? '- Phone : '.($row->phone_number ?? '-') : '';  ?></span>
          <span class="costum-td-details">  <?php echo  $check_class ? '- Email : '.($row->email ?? '-') : '' ;  ?></span>
        </td>
        <td>
          <span class="costum-td-details">- office : <?php echo  $desk->post_name ?? '-' ;  ?> </span>  
          <span class="costum-td-details">- Location : <?php echo  $location[0]->name ?? '-' ;  ?> </span>  
          <span class="costum-td-details">- Building : <?php echo  $building[0]->name ?? '-' ;  ?> </span>  
          <span class="costum-td-details">- Floor : <?php echo  $row->floor ?? '-' ;  ?> </span>  
          <span class="costum-td-details">- Room :<?php echo  $row->room ?? '-' ;  ?> </span>  
          <span class="costum-td-details">- Seat : <?php echo  $row->seat ?? '-' ;  ?> </span>  
          <span class="costum-td-details">- Office Type : <?php echo  $row->desk_type ?? '-' ;  ?> </span>  
        </td>
        <td class="reservations-dates">
          <span>
            From : 
            <?php echo  $row->date_start ?? '-' ;  ?>
          </span>
          <span>
            To :
            <?php echo  $row->date_end ?? '-' ;  ?>
          </span>
        </td>
        <td>
          <span class="costum-td-details">- Order date : <?php echo  $order_created_date ?? '-' ;  ?> </span> 
          <span class="costum-td-details">- VAT : <?php echo  $order_tax ?? '-' ;  ?> </span>  
          <span class="costum-td-details">- Total price : <?php echo  wc_price($total_price) ?? '-' ;  ?> </span> 
          
        </td>
      </tr>
  <?php
      }
  }
      else{
          ?>
  <tr>
    <td>-</td>
    <td>-</td>
    <td>-</td>
    <td>-</td>
  </tr>
          <?php
      }   
  ?>


</tbody>
</table>