<?php
if ( ! defined( 'ABSPATH' ) )   exit; 
wp_enqueue_style('bootstrap-css', BOOKING_PLUGIN_URL . '/assets/style/libraries/bootstrap.min.css');
$locked_rooms = get_option('locked_rooms',[]);
if (isset($_POST['building_for_city']) && !empty($_POST['building_for_city']) && wp_verify_nonce($_POST['building_for_city'], BOOKING_DIRNAME)) {
    $city = $_POST['rooms-location'] && is_numeric($_POST['rooms-location'])  ? $_POST['rooms-location'] : '';
    $building = $_POST['rooms-building'] && is_numeric($_POST['rooms-building'])  ? $_POST['rooms-building'] : '';
    $floor = sanitize_text_field($_POST['rooms-floor']);
    $room = $_POST['rooms-number'] && is_numeric($_POST['rooms-number']) ? $_POST['rooms-number'] : '';
    if(!empty($city) && !empty($building) && !empty($floor) && !empty($room)){
        $key_option = $city.'_'.$building.'_'.$floor.'_'.$room;
        $locked_rooms[$key_option] = array('room'=>$room);
        $updated = update_option('locked_rooms', $locked_rooms);
    }
}
$is_data_saved =false;
$terms = get_terms([
    'taxonomy' => 'workspace-type',
    'hide_empty' => false,
]);
if( isset($_POST['action']) && $_POST['action'] == 'save_settings_booking_desk' && wp_verify_nonce($_POST['settings_booking_desk_nonce'], BOOKING_DIRNAME)  ){
    $data = [];
    if(!is_wp_error($terms) && !empty($terms)){
        foreach ($terms as $term){
            $data_args = array('day'=> 0, 'week'=> 0,'halfday'=> 0);
            if($term->slug == 'meeting-room'){
                $data_args['hour'] = is_numeric($_POST[$term->slug]['hour']) ? $_POST[$term->slug]['hour'] : 0;
                $data_args['halfday'] = is_numeric($_POST[$term->slug]['halfday']) ? $_POST[$term->slug]['halfday'] : 0;
            }
            $data_args['day'] = is_numeric($_POST[$term->slug]['day']) ? $_POST[$term->slug]['day'] : 0;
            $data_args['week'] = is_numeric($_POST[$term->slug]['week']) ? $_POST[$term->slug]['week'] : 0;
            $data_args['month'] = is_numeric($_POST[$term->slug]['month']) ? $_POST[$term->slug]['month'] : 0;
            
            $data[$term->slug] = $data_args;
        }
    }
        $is_data_saved = update_option('desks_price_settings',$data);
}
if (!$is_data_saved){
    $data = get_option('desks_price_settings');
}

$locations = get_terms('location', array('hide_empty' => 0));
?>
 
<div class="wrap">
    <h1 id="h1-st"><?php _e('Settings Area', 'BOOKING-DESKS'); ?></h1>
    <div class="">
        <div class="row">
            <form action="" method="post">
                <fieldset>
                    <h2 class="title">Price Options</h2>
                    <table class="table_price_options">
                        <thead >
                            <tr>
                                <th>Office type</th>
                                <th>Per-HOUR</th>
                                <th>Per-HALF-DAY</th>
                                <th>Per-DAY</th>
                                <th>Per-WEEK</th>
                                <th>Per-Month</th>
                            </tr>
                        </thead>
                                <?php
                                    foreach ($terms as $term){
                                       
                                ?>
                                <tr>
                                    <td><label for="privateoffice"><?php echo $term->name;?></label></td>
                                    <td>
                                        <?php
                                            if($term->slug == 'meeting-room'){
                                        ?>
                                         <input type="text" name="<?php echo $term->slug ?>[hour]" 
                                                id="<?php echo $term->slug ?>" 
                                                value="<?php echo isset($data[$term->slug]['hour']) ? $data[$term->slug]['hour'] : ''; ?>" 
                                                placeholder="price per hour">
                                        <?php
                                          }  else 
                                                echo '-';
                                        ?>

                                    </td>
                                    <td>
                                        <?php
                                            if($term->slug == 'meeting-room'){
                                        ?>
                                         <input type="text" name="<?php echo $term->slug ?>[halfday]" 
                                                id="<?php echo $term->slug ?>" 
                                                value="<?php echo isset($data[$term->slug]['halfday']) ? $data[$term->slug]['halfday'] : ''; ?>" 
                                                placeholder="price per half day">
                                        <?php
                                          }  else 
                                                echo '-';
                                        ?>

                                    </td>
                                    <td> <input type="text" name="<?php echo $term->slug ?>[day]" id="<?php echo $term->slug ?>" value="<?php echo isset($data[$term->slug]['day']) ? $data[$term->slug]['day'] : ''; ?>" placeholder="price per day"></td>
                                    <td> <input type="text" name="<?php echo $term->slug ?>[week]" id="<?php echo $term->slug ?>" value="<?php echo isset($data[$term->slug]['week']) ? $data[$term->slug]['week'] : ''; ?>"  placeholder="price per week"></td>
                                    <td> <input type="text" name="<?php echo $term->slug ?>[month]" id="<?php echo $term->slug ?>" value="<?php echo isset($data[$term->slug]['month']) ? $data[$term->slug]['month'] : ''; ?>"  placeholder="price per month"></td>
                                </tr>
                                <?php
                                    }
                                ?>
                                <tr>
                                    <input type="hidden" name="action" value="save_settings_booking_desk" >
                                    <?php wp_nonce_field(BOOKING_DIRNAME, 'settings_booking_desk_nonce'); ?>
                                </tr>
                                <tr>
                                    <td>
                                        <input type="submit" value="save" class="btn-chang-layout">
                                    </td>
                                </tr>
                            </table>
                        </fieldset>
                    </form>
            </div>
            <div class="row manage-rooms">
            <h2 class="title">Manage Rooms </h2>
            <div class="main-panel">
                <form action="" method="post"  class="f-manag-r">

<table class="table_manage_rooms"> 
    <tr>
        <td><label for="rooms-location"> Location :</label></td>
        <td> 
            <select class="rooms-location" name="rooms-location">
                <option value="0">choose location</option>
                    <?php if(!empty($locations)): 
                        $opts = '';
                        foreach ($locations as $location) {
                            $opts .= ' <option value="'.$location->term_id.'">'.$location->name.'</option>';
                        }
                        echo $opts;
                        ?>
                    <?php endif; ?>
            </select>
        </td>
  
    <td  class="dv-building"><label for="rooms-building"> Building :</label></td>
    <td  class="dv-building">
        <select class="rooms-building" name="rooms-building">
            <option value="0">select building</option>
        </select>
    </td>
    <td  class="dv-floor"><label for="rooms-floor"> Floor :</label></td>
    <td  class="dv-floor"> 
        <select class="floor-floor" name="rooms-floor">
            <option value="0">choose floor</option>
        </select>
    </td>
    <td  class="dv-room"><label for="rooms-number"> Room number :</label></td>
    <td class="dv-room"><input type="number" name="rooms-number" id="rooms-number"></td>
</tr>
<tr>
    <td>
        <input type="submit" name="submitbtn_lockroom" id="submitbtn_lockroom" value ='Lock the Room' class="btn-chang-layout">
        <?php wp_nonce_field(BOOKING_DIRNAME,'building_for_city') ;  ?>
    </td>
</tr>
</table>



                </form>
            </div>
            <?php if(!empty($locked_rooms)) : ?>

            <div class='displying-title'>
                <h3> Locked Rooms</h3>
                <table class='locked-rooms'>
                    <thead class="thead-orange">
                        <tr>
                            <th>Location</th>
                            <th>Building</th>
                            <th>Floor</th>
                            <th>Room</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                        <?php foreach ($locked_rooms as $key => $value) : 
                            $details = explode('_',$key);
                            $city = get_term_by('id',$details[0],'location');
                            $building = get_term_by('id',$details[1],'buildings');
                            $floor = $details[2]?? '';
                            $city = $city->name ?? '' ;
                            $building = $building->name ?? '';
                            $room = $details[3]?? '';
                            ?>
                        <tr>
                            <td><?php echo $city; ?></td>
                            <td><?php echo $building; ?></td>
                            <td><?php echo $floor; ?></td>
                            <td><?php echo $room; ?></td>
                            <td>
                                <button class="action-btn delete-btn" data-key-id="<?php echo $key; ?>"> Delete </button>
                            </td>

                        </tr>
                        <?php endforeach ; ?>
                </table>
            </div>
            <?php endif; ?>
        </div>
    </div>
</div>
