<?php

if ($is_administrator) :
    $cleaner = '';
    if( isset($_GET['submitbtn_find_room_by_cleaner']) && wp_verify_nonce($_GET['find_roms_by_cleaner'], BOOKING_DIRNAME.'--')){
        $selected_cleaner = sanitize_text_field($_GET['cleaners-select']);
        if(!empty($selected_cleaner))
            $cleaner =  " and cleaner_id = $selected_cleaner ";
         
    }

    $_cleaners = get_cleaners(true);
?>
<div class="main-panel">
    <form method="GET" class="f-manag-r">
        <table class="table_manage_rooms">
            <tbody>
                <tr>
                    <td><label for="rooms-location"> Cleaners :</label></td>
                    <td>
                        <?php
                            echo $_cleaners['html'];
                        ?>
                    </td>
                </tr>
                <tr>
                    <td>
                        <input type="hidden" value="display" name="tab">
                        <input type="hidden" value="<?php echo $_GET["page"]; ?>" name="page">
                        <?php wp_nonce_field(BOOKING_DIRNAME.'--', 'find_roms_by_cleaner');  ?>
                        <input type="submit" name="submitbtn_find_room_by_cleaner" id="submitbtn_vacated_room" value="Filter by cleaners" class="btn-chang-layout">
                    </td>
                </tr>
            </tbody>
        </table>
    </form>
</div>
<?php
endif;

if(!isset($cleaner)){
    $current_user =  get_current_user_id() ;
    $cleaner =" and cleaner_id = $current_user " ;
}

global $wpdb;
$tablename = $wpdb->prefix . 'booking_info';

// $sql_query = "select * from $tablename  $cleaner GROUP BY date_end,room " ;
$sql_query = "select * from $tablename where booking_type = 'cleaning' $cleaner" ;
$results = $wpdb->get_results($sql_query,ARRAY_A);
if(!empty($results)){

?>


<div class="displying-title">
    <h3> Cleaning list </h3>
    <table class="locked-rooms">
        <thead class="thead-orange">
            <tr>
            <?php 
            if ($is_administrator){
                ?>
                <th>Cleaners</th>
                <?php
            }
            ?>
                <th>Location</th>
                <th>Building</th>
                <th>Floor</th>
                <th>Room</th>
                <th>Last scheduled clean up</th>
            </tr>
        </thead>
        <tbody>
            <?php
            $all_cleaners = $_cleaners['data'];
            $new_res = [];
            foreach( $results as $bocking_row ){

                $displayed_name = '';
                if($is_administrator){
                    $the_cleaner = array_filter($all_cleaners,function($cl) use ($bocking_row) { 
                        return $cl->id == $bocking_row['cleaner_id']; 
                    });
                    if(!empty($the_cleaner))
                        $displayed_name = $the_cleaner[0]->display_name;
                }
                $_location = get_the_terms($bocking_row['desk_id'],'location');
                $_building = get_the_terms($bocking_row['desk_id'],'buildings');
                $key = $displayed_name . $_location[0]->name . $_building[0]->name . $bocking_row['floor'] . $bocking_row['room'];
                if(empty($new_res[$key])){
                    $last_cleaning = get_last_cleaning_date($_location[0]->term_id,$_building[0]->term_id,$bocking_row['floor'],$bocking_row['room']);
                    $html_last_cleaning_date = '';
                    if(!empty($last_cleaning)){
                        $html_last_cleaning_date = '<ul>';
                        $html_last_cleaning_date .= implode('', array_map(fn($date) => "<li>{$date['date_end']}</li>", $last_cleaning));
                        $html_last_cleaning_date .= '</ul>';
                    }
                    $new_res[$key] = [
                        'the_cleaner' => $displayed_name,
                        '_location' => isset($_location[0]->name) ? $_location[0]->name : '',
                        '_building' => isset($_building[0]->name) ? $_building[0]->name : '',
                        'floor' => $bocking_row['floor'],
                        'room' => $bocking_row['room'],
                        'last_cleaning' => $html_last_cleaning_date
                    ];
                }
            }
            if(!empty($new_res)){
                $table_tr = '';
                foreach ($new_res as $book_row) {
                    $table_tr .= '<tr class="tr-room-1">
                                    <td>'.$book_row['the_cleaner'].'</td>
                                    <td>'.$book_row['_location'].'</td>
                                    <td>'.$book_row['_building'].'</td>
                                    <td>'.$book_row['floor'].'</td>
                                    <td>'.$book_row['room'].'</td>
                                    <td>'.$book_row['last_cleaning'].'</td>
                                </tr>';

                }
                echo $table_tr;
            }
            ?>
        </tbody>
    </table>
</div>
<?php
}
else
    echo '<h3>No cleaning yet</h3>';