jQuery(document).ready(function($){
    $('#filter-booking-date').daterangepicker({
        autoUpdateInput: false,
        locale: {
          format: 'DD/MM/YYYY',
          cancelLabel: 'Clear'
        }
      }, function(start, end, label){});

      $('#filter-booking-date').on('apply.daterangepicker', function(ev, picker) {
          $(this).val(picker.startDate.format('DD/MM/YYYY') + ' - ' + picker.endDate.format('DD/MM/YYYY'));
      });
      
      $('#filter-booking-date').on('cancel.daterangepicker', function(ev, picker) {
          $(this).val('');
      });

      $('#customer').keyup(function(){
            keyword = $(this).val();
            token = $('#_nonce_keyword').val();
            $('.search-resilt-box').remove();
            if(keyword.length > 3){
                $.ajax({
                    type: 'POST',
                    url: '/',
                    data : {
                        'token':token,
                        'action' : 'get_searched_keyword',
                        'keyword':keyword                                    
                    },
                    success: function (response) {
                        $('.search-resilt-box').remove();
                        html_res = '<div class="search-resilt-box">';
                                    
                        if(response.length == 0 || response == undefined || response == ''){
                            html_res += '<span class="notexist"> Customer not found !! </span>';
                        }
                        else{
                            $.each(response, function(index, object) {
                                html_res +='<span data-val="'+object.last_name+'">'+object.first_name+' '+object.last_name+'</span>';
                              });
                        }
                        html_res += '</div>';
                        $('.container-result-search').append(html_res);
                    },
                    error: function (error) {
                    }
              });
            }
      });

      $(document).on('click','.search-resilt-box span',function () {
            val = $(this).data('val');
            $('#customer').val(val);
            $('.search-resilt-box').remove();
      });


});