jQuery(document).ready(function($){

    var mediaUploader;

    $('#my-gallery-upload-button').on('click', function(e) {

        e.preventDefault();

        if (mediaUploader) {

            mediaUploader.open();

            return;

        }

        mediaUploader_attr = {

            title: 'Select Images',

            button: {

                text: 'Add to Gallery'

            },

            multiple: true

        };

        test_page = (admin_vars['cuurent_page'] == 'term.php' || admin_vars['cuurent_page'] == 'edit-tags.php');

        var_name = 'my-gallery-images[]';

        if( test_page ){

            mediaUploader_attr.title = 'Select Image';

            mediaUploader_attr.button.text = 'Add Image';

            mediaUploader_attr.multiple = false;

            var_name = 'workspace-icon';

        }

        mediaUploader = wp.media(mediaUploader_attr);

        mediaUploader.on('select', function() {

            var attachments = mediaUploader.state().get('selection').toJSON();

            console.log(attachments);

            var imageIds = [];

            if(test_page){

                $('.my-gallery-images li').remove();

            }

            $.each(attachments, function(index, attachment) {

                imageIds.push(attachment.id);

                var img = '<li><img src="' + attachment.url + '" style="width:100px;height:100px"/><input type="hidden" name="'+var_name+'" value="' + attachment.id + '" /><a href="#" class="my-remove-image">&times;</a></li>';

                $('.my-gallery-images').append(img);

            });

            if( !test_page ){

                $('#my-gallery-images').val(imageIds.join(','));

            }

        });

        mediaUploader.open();

    });

    $('body').on('click', '.my-remove-image', function(e) {

        e.preventDefault();

        $(this).parent().remove();

    });



    $(document).on('change','.rooms-location',function(){

        city = $(this).val();

        $(".dv-building,.dv-floor,.dv-room").hide();

        nonce = $('#building_for_city').val(); 

        if(city != undefined && city != 0 && city != ''){

            $.ajax({

                type: "POST",

                url: '/',

                data: {

                    action:'get_buildings_in_location', 

                    location:city,

                    check_availability:nonce,

                },

                success: function(html){

                   $('.rooms-building').html(html);

                   $(".dv-building").show();

                }

            });

        }

    }); 



    $(document).on('change','.rooms-building',function(){        

        builiding = JSON.parse($(this).val());

        builiding = builiding.id;

        $(".dv-floor,.dv-room").hide(); 

        nonce = $('#building_for_city').val(); 

        if(builiding != undefined && builiding != 0 && builiding != ''){

            $.ajax({

                type: "POST",

                url: '/',

                data: {

                    action:'get_floor_in_building', 

                    builiding:builiding,

                    check_availability:nonce,

                },

                success: function(res){

                    if(!jQuery.isEmptyObject(res)) {

                        html = '<option value="0">Select Floor</option>';

                        $.each(res, function(key,val){

                            floor_title = key.replace('-',' ');

                            html += '<option value="'+floor_title+'">'+floor_title+'</option>';

                        });

                        $('.floor-floor').html(html);

                        $(".dv-floor").show();

                    }

                }

            });

        }

    }); 

    $(document).on('change','.floor-floor',function(){

        $(".dv-room").show(); 

    });     



    



    $(document).on('click','.action-btn',function () {

        thiss =$(this);

        key_id = $(this).attr('data-key-id');

        nonce =  $('#building_for_city').val();

        if( key_id != undefined && key_id != ''){

            $.ajax({

                type: "POST",

                url: '/',

                data: {

                    action:'lock_room_Action', 

                    check_availability_nonce:nonce,

                    key_id :key_id  

                },

                success: function(res){

                    if(res =='true'){

                        $(thiss).closest('tr').remove();

                        alert('room unblocked');

                    }

                    else if(res =='false'){

                        alert('please try later');

                    }

                }

            });

        }



    });
    
    // Find the "Move to Trash" links and bulk action button by their CSS classes
    var trashLinks = $('.submitdelete');
    var bulkTrashButton = $('#doaction, #doaction2')

    // Attach a click event handler to the "Move to Trash" links
    trashLinks.on('click', function (e) {
        // Prevent the default click action
        e.preventDefault();

        confirmation_message = 'Are you sure you want to move this desk to the trash?';
        if( $(this).text() == 'Delete Permanently' ){
            confirmation_message = 'Are you sure you want to delete this desk Permanently?';
        }
        // Display a confirmation dialog
        if (confirm(confirmation_message)) {
            // If confirmed, proceed with the original click action
            window.location.href = $(this).attr('href');
        }
    });

    // Attach a click event handler to the bulk action button
    bulkTrashButton.on('click', function (e) {
        // Get the selected posts
        selected_option = $('select[name="action"]').val();
        triggred = $(this).data('triggred');
        
        if ( (selected_option == 'trash' || selected_option == 'delete' ) && triggred != 'yes'  ){
            e.preventDefault();
            var selectedPosts = $('input[name="post[]"]:checked');
            // Check if any posts are selected
            if (selectedPosts.length > 0) {
                // Prevent the default click action
    
                // Display a confirmation dialog for bulk post deletion
                var confirmMessage = 'Are you sure you want to move these desks to the trash?';
                if(selected_option == 'delete'){
                     confirmMessage = 'Are you sure you want to delete these desks Permanently?';
                }
                if (confirm(confirmMessage)) {
                    $(this).data('triggred','yes')
                    // If confirmed, proceed with the original click action
                    $(this).trigger('click');
                }
            }
        }
    });

})

