<?php

//////////////////////// ACTIONS ///////////////////////////
add_action('wp_enqueue_scripts', 'enqueue_custom_scripts');
add_action('init', 'get_working_space_and_floors_ajax');
add_action('admin_enqueue_scripts', 'my_enqueue');
add_action('init', 'page_details_rewrite_rules');
add_action('wp', 'prefix_url_rewrite_templates', 2001);
add_action ( 'edit_tag_form_fields', 'tag_input_metabox' );
add_action ( 'edited_terms', 'save_tag_data',10,2 );
add_action('buildings_edit_form','add_floors_details');
add_action('buildings_term_edit_form_tag', 'add_enctype_to_form');
add_action('init', 'get_buildings_in_location');
add_action('add_meta_boxes_desks','add_desks_meta_boxes');
add_action( 'init', 'ajax_settings_call' );
add_action( 'wc_ajax_custom_add_to_cart', 'custom_add_to_cart_handler' );
add_action( 'wc_ajax_nopriv_custom_add_to_cart', 'custom_add_to_cart_handler' );
add_action( 'admin_bar_menu', 'customize_my_wp_admin_bar', 80 );
add_action( 'rest_api_init', 'create_api_posts_meta_field' );
add_action( 'woocommerce_checkout_create_order_line_item', 'save_cpt_id_to_order_item_data', 10, 4 );
add_action('woocommerce_checkout_update_order_meta','set_etat_reservation_payement_woocomerce');
add_action( 'manage_buildings_custom_column', 'wpdocs_show_buildings_meta_info_in_columns', 10, 3 );
add_action( 'woocommerce_review_order_before_submit', 'accept_rgpd', 10 );
add_action( 'woocommerce_checkout_process', 'accept_rgpd_erreur' );
add_action( 'woocommerce_before_checkout_form', 'display_login_form_on_checkout');
add_action( 'user_register', 'auto_login_after_registration' );
add_action( 'register_form','add_fields_to_resister_form');
add_action('save_post', 'save_post_data',10,2);
add_action( 'admin_notices', 'show_admin_notices');
add_action( 'admin_init', 'redirect_admin_dashboard' );
add_action('admin_init', 'disable_autosave');
add_action( 'current_screen', 'remove_filtre_by_user', 11 );
add_action( 'check_ajax_referer', 'remove_filtre_by_user', 11 );
add_action('wp_trash_post', 'custom_check_before_delete_post');
add_action( 'template_redirect', 'empty_cart_redirection' );

//////////////////////// FILTERS ///////////////////////////
add_filter('add_to_cart_redirect', 'lw_add_to_cart_redirect');
add_filter( 'woocommerce_data_stores', 'woocommerce_data_stores' );
add_filter('woocommerce_get_price', 'woocommerce_product_get_price', 10, 2 );
add_filter('post_item_container_class','change_class_post_item',10,2);
add_filter('post_item_image_class','change_class_post_item_image',10,2);
add_filter('post_item_body_class','change_class_post_item_body',10,2);
add_filter( 'woocommerce_checkout_fields' , 'custom_override_checkout_fields' );
add_filter( 'woocommerce_get_country_locale', 'change_postcode_local_label' );
add_filter( 'woocommerce_locate_template', 'woo_locate_template_in_plugin', 1, 3 );
add_filter( 'woocommerce_default_address_fields', 'custom_default_address_fields' );
add_filter( 'woocommerce_product_tabs', 'my_remove_product_tabs', 98 );
add_filter('login_redirect', 'dashboard_redirect',10,3);
add_filter( 'woocommerce_add_cart_item_data', 'add_custom_cart_item_data', 10, 3 );
add_filter( 'manage_edit-buildings_columns', 'wpdocs_add_new_buildings_columns' );
add_filter('floors_spell','change_floor_spell',10,3);
add_filter( 'wp_insert_post_empty_content', 'disable_save', 10, 2 );
add_filter( 'woocommerce_return_to_shop_redirect', 'change_return_to_cart_url' );
add_filter('woocommerce_checkout_cart_item_quantity','__return_empty_string');
add_filter('woocommerce_disable_admin_bar','__return_false');
add_filter('woocommerce_return_to_shop_text', 'custom_woocommerce_return_to_shop_text');
add_filter('woocommerce_return_to_shop_redirect', 'custom_return_to_shop_redirect');

//////////////////////// FUNCTIONS /////////////////////////



function custom_woocommerce_return_to_shop_text() {
    return 'Back to home'; // Change 'Your Custom Text Here' to your desired button text
}

function custom_return_to_shop_redirect($return_to_shop_url) {
    return '/';
}



function custom_check_before_delete_post($post_id) {
    // Check if the post is of a specific post type (e.g., 'post' or 'page')
    if (get_post_type($post_id) === 'desks') {
        global $wpdb;
    
        $query = "SELECT date_end FROM  {$wpdb->prefix}booking_info where desk_id = $post_id ";
        
        $reservations_dates = $wpdb->get_results($query,ARRAY_A);

        if(empty($reservations_dates))
            return;
        $_reservations_dates = array_column($reservations_dates, "date_end");
        $currentTimestamp = time(); 
        $isCurrentTimeLower = false;
        // Loop through each time in the array
        foreach ($_reservations_dates as $time) {
            $timeTimestamp = strtotime($time);
            // Compare the current time with the time from the array
            if ($currentTimestamp < $timeTimestamp) {
                $isCurrentTimeLower = true;
                break; // Exit the loop as soon as a lower time is found
            }
        }
        if($isCurrentTimeLower)
            wp_die("You can't delete this desk ,Already reserved!!! ");
            
        return;
    }
}

function ajax_settings_call(){
    if ( isset($_POST['key_id']) && isset($_POST['action']) && $_POST['action'] == "lock_room_Action" && wp_verify_nonce($_POST['check_availability_nonce'], BOOKING_DIRNAME)) {
        $locked_rooms = get_option('locked_rooms',[]);
        if( isset($locked_rooms[$_POST['key_id']]) ){
            unset($locked_rooms[$_POST['key_id']]);
            $res = update_option('locked_rooms',$locked_rooms);
            echo $res ? 'true' : 'false';
            die;
        }
    }
    elseif(isset($_POST['action']) && $_POST['action'] == "reservetoclean" && wp_verify_nonce($_POST['check_availability'], BOOKING_DIRNAME)){
      $room = is_numeric($_POST['room']) ? $_POST['room'] : 0 ;
      $date_start = prase_time_to_date_Time($_POST['starttime']);
      $date_end = prase_time_to_date_Time($_POST['endtime']);
      $floor = get_floor_from_string($_POST['floor']);
      $cleaner = is_numeric($_POST['cleaner'] ?? null) ? $_POST['cleaner'] : 0 ;
      $location = is_numeric($_POST['location'] ?? null) ? $_POST['location'] : 0 ;
      $building = is_numeric($_POST['building'] ?? null) ? $_POST['building'] : 0 ;
      $curent_user_role = get_the_user_roles();
      if(in_array('administrator',$curent_user_role) && !$cleaner){
          echo ' You should select a cleaner ';
          die;
      }
      elseif(in_array('cleaner',$curent_user_role)){
         $user_info = wp_get_current_user();
         $cleaner = $user_info->ID;
      }
      if($room && $date_start && $date_end && !empty($floor) && $location && $building && $cleaner){
            $args = array('room'=>$room,
                          'floor' => $floor,
                          'location'=>$location,
                          'building'=>$building,
                          'date_start'=>$date_start,
                          'date_end'=>$date_end,
                          'cleaner' => $cleaner,
                          'booking_type'=> 'cleaning'
                         );

            $reserved = set_room_cleaning_schedule($args); 
            echo $reserved;
            die;
      }
    }
    elseif(isset($_POST['token']) && isset($_POST['action']) && $_POST['action'] == "get_searched_keyword" && wp_verify_nonce($_POST['token'], BOOKING_DIRNAME)){
        $key_word = sanitize_text_field($_POST['keyword']);
        if(!empty($key_word)){
            global $wpdb;
            $query = "SELECT first_name,last_name FROM {$wpdb->prefix}client_info  where first_name LIKE '%$key_word%' OR last_name LIKE '%$key_word%' LIMIT 25";
            $results =  $wpdb->get_results($query);
            wp_send_json($results);
            die;
        }
    }
}
function change_floor_spell($spell,$floors_spell,$floor){
    $spell = $floor == 'ground' ? 'Ground' : $floors_spell[$floor-1];
    return $spell;
}
function enqueue_custom_scripts()
{
    wp_enqueue_script('jquery-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/jquery.min.js');
    wp_enqueue_script('moment-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/moment.min.js');
    wp_enqueue_script('daterangepicker-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/daterangepicker.min.js');
    wp_enqueue_script('bootstrap', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/bootstrap.min.js');
    wp_enqueue_script('slick-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/slick.min.js',['jquery-js']);
    wp_enqueue_script('main-js', BOOKING_PLUGIN_URL . '/assets/javascripts/main.js');
    wp_enqueue_style('bootstrap-css', BOOKING_PLUGIN_URL . '/assets/style/libraries/bootstrap.min.css');
    wp_enqueue_style('daterangepicker-css', BOOKING_PLUGIN_URL . '/assets/style/libraries/daterangepicker.css');
    wp_enqueue_style('global-css', BOOKING_PLUGIN_URL . '/assets/style/global.css');
    wp_enqueue_style('slick-css', BOOKING_PLUGIN_URL . '/assets/style/libraries/slick.css');
    wp_enqueue_style('slick-theme-css', BOOKING_PLUGIN_URL . '/assets/style/libraries/slick-theme.css');

    $is_user_logged_in = is_user_logged_in();

    wp_localize_script('main-js', 'script_vars', array(
        'BOOKING_PLUGIN_URL'  => BOOKING_PLUGIN_URL,
        'isUserLoggedIn' => $is_user_logged_in,
    ));
}


function get_working_space_and_floors_ajax()
{
    if (isset($_POST['action']) && $_POST['action'] == "get_working_space_and_floors" && wp_verify_nonce($_POST['check_availability'], BOOKING_DIRNAME)) {
        define('DOING_AJAX', true);
        if (!empty($_POST['building_id'])) {
            $terms = get_terms('buildings', array('hide_empty' => 0, 'parent' => $_POST['building_id']));
            if (!empty($terms)) {
                $html = '<div class="col-sm-6">
                            <label for="floorselect"> Floor : </label>
                        </div>
                        <div class="col-sm-6">
                            <div class="form-group">
                                <select class="form-control" id="floorselect" name="floorselect" >
                                    <option value="0">All floors</option>';
                foreach ($terms as $term) {
                    $html .= '<option value="' . $term->term_id . '">' . $term->name . ' </option>';
                }

                $html .= '</select>
                            </div>
                        </div>';
            }
        }
        elseif(!empty($_POST['floors_id'])){
        $html = 'No working space diponible in this floors';
            $terms = get_terms('buildings', array('hide_empty' => 0, 'parent' => $_POST['floors_id']));
            if (!empty($terms)) {
                $html = '<div class="col-sm-6">
                            <label for="Buildings"> Resource : </label>
                        </div>
                        <div class="col-sm-6">
                            <div class="form-group">
                                <select class="form-control" id="working_space" name="working_space" >
                                    <option value="0">All workspaces</option>';
                foreach ($terms as $term) {
                    $html .= '<option value="' . $term->term_id . '" >' . $term->name . ' </option>';
                }

                $html .= '</select>
                            </div>
                        </div>';
                }
        }

        echo $html;
        exit;
    }
    if (isset($_POST['action']) && $_POST['action'] == "get_floor_in_building" && wp_verify_nonce($_POST['check_availability'], BOOKING_DIRNAME)) {
        if(is_numeric($_POST['builiding'])){
            $floors = get_term_meta($_POST['builiding'],'floors_images',true);
            if(empty($floors) || !$floors ) $floors = [];
            wp_send_json($floors);
        }
    }
  }

function my_enqueue($hook)
{
    wp_enqueue_style('global-css', BOOKING_PLUGIN_URL . '/assets/style/global-admin.css');
    wp_enqueue_script('global-booking-js', BOOKING_PLUGIN_URL . '/assets/javascripts/global-admin.js');
    if ('edit-tags.php' == $hook || 'term.php' == $hook ) {
        wp_enqueue_script('edit-tags-js', BOOKING_PLUGIN_URL . '/assets/javascripts/edit_tags.js');
        wp_enqueue_media();
    } elseif (in_array($hook, array('post.php', 'post-new.php')) && 'desks' == get_post_type()) {
        wp_enqueue_script('moment-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/moment.min.js');
        wp_enqueue_script('daterangepicker-js', BOOKING_PLUGIN_URL . '/assets/javascripts/libraries/daterangepicker.min.js');
        wp_enqueue_style('daterangepicker-css', BOOKING_PLUGIN_URL . '/assets/style/libraries/daterangepicker.css');
        wp_enqueue_script('savedesks-js', BOOKING_PLUGIN_URL . '/assets/javascripts/savedesks.js');
    }
    wp_localize_script('global-booking-js', 'admin_vars', array(
        'cuurent_page'  => $hook,
    ));
}

add_filter('query_vars', function ($vars) {
    $vars[] = "page_name";
    $vars[] = "desk";
    $vars[] = "date_start";
    $vars[] = "date_end";

    return $vars;
});

function page_details_rewrite_rules()
{
    add_rewrite_rule('(results-desks)','index.php?page_name=$matches[1]','top');
    if( !get_option('plugin_permalinks_flushed') ) {
        flush_rewrite_rules();
        update_option('plugin_permalinks_flushed', 1);
    }
}

function prefix_url_rewrite_templates()
{
    global $wp_query;
    $taxonomie = 'buildings';
    $page_name = get_query_var('page_name');
    if($page_name == 'results-desks'){
        if (wp_verify_nonce($_POST['check_availability'], BOOKING_DIRNAME) || wp_verify_nonce($_POST['nonce'], BOOKING_DIRNAME) ) {
            $floors_spell = return_ordinal_number();
            $workspace_type = get_terms('workspace-type', array('hide_empty' => 0));
            $dates = str_replace(' - ','-',$_POST['Dates-range']);
            $dates = explode('-',$dates);
            $date_start =  $dates[0]  ;
            $date_end =  $dates[1];
            $dates_time = prase_date_to_date_Time($date_start,$date_end);
            $date_start =$dates_time[0];
            $date_end =$dates_time[1];
            $diff_date = get_date_diff($date_start,$date_end);
            $cuurent_workspace = $_POST['workspace'] ;
            if( !is_array($cuurent_workspace) ){
                $arr[] =  $cuurent_workspace; 
                $cuurent_workspace = $arr;
            }
            $cuurent_workspace = array_filter($cuurent_workspace,'is_numeric') ; 
            $cuurent_workspace = empty($cuurent_workspace) ? [0] : $cuurent_workspace;

            $selected_view = $_POST['view_type_val'] ;
            if (!empty($_POST['action']) && $_POST['action'] == "change-view-type") {
                ob_start();
                include(BOOKING_PLUGIN_DIR . '/includes/templates/template-parts/croquis.php');
                $output = ob_get_contents();
                ob_end_clean();
                echo $output;
                die;
            }
            if( !empty($_POST['request']) && $_POST['request'] == 'ajax' ){
                ob_start();
                include(BOOKING_PLUGIN_DIR . '/includes/templates/template-parts/croquis.php');
                $output = ob_get_contents();
                ob_end_clean();
                echo $output;
                die;
            }
            get_header();
            include(BOOKING_PLUGIN_DIR . '/includes/templates/desks-results.php');
            get_footer();
            exit;
    } else {
        if( !empty($_POST['request']) && $_POST['request'] == 'ajax' ){
            echo 'Please Check later';
            die();
        }
        wp_redirect(home_url(), 301);
        exit();
        }
    }
}

function add_enctype_to_form()
{
    echo 'enctype="multipart/form-data"';
}

function add_floors_details($args){
    // wp_enqueue_script('buildings_script',  BOOKING_PLUGIN_URL . '/assets/javascripts/');

    $floors_images = get_term_meta($args->term_id, 'floors_images', true);
    $count_rooms = get_term_meta($args->term_id,'rooms_count',true);
    // echo'<pre>'; var_dump($count_rooms); echo'</pre>';
?>
<div class="floor-panel">
    <h2 style="text-align: center; font-size: 30px;">Floors Details</h2>
    <div class="main-body">
        <table class='floors-details'>
            <tr class="table-head">
                <th class="center-itm"><span><img width="25px" src="<?php echo BOOKING_PLUGIN_URL.'/assets/images/floor.svg' ?>" alt=""></span> Floors</th>
                <th class="center-itm"><span><img width="25px" src="<?php echo BOOKING_PLUGIN_URL.'/assets/images/layout.svg' ?>" alt=""></span> Layout</th>
                <th class="center-itm"><span><img width="25px" src="<?php echo BOOKING_PLUGIN_URL.'/assets/images/plan.svg' ?>" alt=""></span> Plan </th>
                <th class="center-itm"><span><img width="25px" src="<?php echo BOOKING_PLUGIN_URL.'/assets/images/plan.svg' ?>" alt=""></span> Count Rooms</th>
            </tr>
            <?php
                if(!empty($floors_images['ground-floor'])){
                    ?>
                <tr class="ground-floor-opt">
                    <td class="center text">Ground floor</td>
                    <td class="center">
                        <label class="btn-chang-layout" for="floor-image-ground-floor">Change the layout</label>
                        <input type="file" id="floor-image-ground-floor" name='floor-image-ground-floor' class='image-importer floor-number-ground' data-floor='ground' style="display:none;" />
                    </td>
                    <td class="center"><a href="<?php echo site_url('/wp-admin/admin.php?page=offices-place&plan='.$floors_images['ground-floor'].'&building='.$args->term_id.'&floor=ground'); ?>">
                    <?php echo wp_get_attachment_image($floors_images['ground-floor'],'thumbnail',false,array('class'=>'imported-floor-image floor-ground')); ?></a></td>
                    <td class="center">
                        <input type="number" id="floor-rooms-count-ground-floor" name='floor-rooms-count[ground-floor]'
                                class='floor-count-rooms' value='<?php echo !empty($count_rooms['ground-floor']) ? $count_rooms['ground-floor'] : '' ?>' />
                    </td>
                </tr>
            <?php
                unset($floors_images['ground-floor']);
                }
            if (!empty($floors_images)):
                $i = 0;
                foreach($floors_images as $floor => $id_attachement){
                    $indce = $i + 1;
                    ?>

            <tr class="floor-row floor-row-<?php echo $floor; ?>">
                <td class="center text"><?php echo $floor;  ?></td>
                 <td class="center">
                    <label class="btn-chang-layout" for="floor-image-<?php echo $indce; ?>st-floor">Change the layout</label>
                    <input type="file" id="floor-image-<?php echo $indce; ?>st-floor" name='floor-image-<?php echo $indce; ?>st-floor' class='image-importer floor-number-<?php echo $indce; ?>' data-floor='<?php echo $indce; ?>' style="display:none;" />
                </td>
                <td class="center"><a href="<?php echo site_url('/wp-admin/admin.php?page=offices-place&plan='.$id_attachement.'&building='.$args->term_id.'&floor='.$indce); ?>">
                    <?php echo wp_get_attachment_image($id_attachement,'thumbnail',false,array('class'=>'imported-floor-image floor-'.$indce)); ?></a></td>
                    <td class="center">
                        <input type="number" id="floor-rooms-count-<?php echo $indce; ?>-floor" name='floor-rooms-count[<?php echo $indce; ?>-floor]' 
                                value='<?php echo !empty($count_rooms[$indce.'st-floor']) ? $count_rooms[$indce.'st-floor'] : '' ?>' class='floor-count-rooms' />
                    </td>
            </tr>
            <?php
            $i++;
                }
        endif; ?>
        </table>
    </div>
</div>

<?php
}
function tag_input_metabox($term) {

    if($term->taxonomy =='buildings' && $term->parent == 0){
        $current = get_term_meta($term->term_id, 'city_of_building',true);
        $cities = get_terms('location', array('hide_empty' => 0));
        $number_floor = get_term_meta($term->term_id, 'number_floor',true);
        // $building_maps_iframe = get_term_meta($term->term_id, 'building_maps_iframe',true);
        ?>
<tr class="form-field">
    <th scope="row" valign="top"><label for="tag_widget"><?php _e('Location') ?></label></th>
    <td>
        <select name='cities' id='cities'>
            <option value="0">cities</option>
            <?php
                    foreach($cities as $city){
                        echo '<option value="'.$city->term_id.'" '. ($city->term_id == $current ? 'selected':'') .'>'.$city->name.'</option>';
                    }
                    ?>
        </select>
    </td>
</tr>

<tr class="form-field">
    <th scope="row" valign="top"><label for="tag_widget"><?php _e('Floors') ?></label></th>
    <td>
        <input type="number" name="number-floor" id="number-floor" value="<?php echo isset($number_floor['number-floor']) ? $number_floor['number-floor'] : '' ; ?>" min="1" max="4"> <p class="description"> Floor count </p>
    </td>
    <td> <label for="ground-floor">
        <input type="checkbox" name="ground-floor" id="ground-floor" <?php echo isset($number_floor['ground-floor']) && $number_floor['ground-floor'] ? 'value="true" checked' : 'value="false"' ; ?> > + the Ground floor </label>
    </td>
</tr>

<tr class="form-field">
    <th scope="row" valign="top"><label for="tag_widget"><?php _e('Location in the Maps (Iframe) : ') ?></label></th>
    <td>
        <textarea id="maps-ifarame" name="maps-ifarame"
          rows="5" cols="33">
                <?php //echo $building_maps_iframe; ?>
        </textarea>

    </td>
</tr>
<?php
    }
    elseif ($term->taxonomy =='workspace-type') {
        $icon = get_term_meta($term->term_id, 'workspace_type_icon',true);
        $reservations ='<div class="my-gallery-container"><ul class="my-gallery-images">';
            if ( !empty($icon) ) :
                    $image = '<img src="'.$icon['icon_url'].'" class="workspace-type-icon" />';
                    $reservations .='<li>'. $image .'<input type="hidden" name="workspace-icon" value="'. $icon['id_attch'] .'" /><a href="#" class="my-remove-image">&times;</a></li>';
            endif;
        $reservations .='</ul></div>';
        ?>
        <tr class="form-field">
            <th scope="row" valign="top"><label for="tag_widget"><?php _e('Icon') ?></label></th>
            <td> 
                <button id="my-gallery-upload-button" class="button">Add Image</button>
            </td>
            <td> 
                <?php echo $reservations; ?>
            </td>
        </tr>
        <?php
    }
}

function save_tag_data($term_id,$taxonomy) {
    if($taxonomy == 'workspace-type'){
        $icon = [];
        $id_attch = is_numeric($_POST['workspace-icon']) ? $_POST['workspace-icon'] : '';
        if (!empty($id_attch)){
            $icon['id_attch'] = $id_attch;
            $icon['icon_url'] = wp_get_attachment_image_url($icon['id_attch'], 'full');
        }
        update_term_meta($term_id, 'workspace_type_icon', $icon);
    }
    elseif ($taxonomy == 'buildings'){

    if (isset($_POST['cities'])) {
        $tag_metadata = esc_attr($_POST['cities']);
        update_term_meta($term_id,'city_of_building', $tag_metadata);
    }
    if(!empty($_POST['maps-ifarame'])){
        $iframe =  $_POST['maps-ifarame'];
        // update_term_meta($term_id, 'building_maps_iframe',$iframe);
    }
// ----------------------  uplpad files  --------------------------------- //
    $ground = !empty($_FILES['floor-image-ground-floor']['size']) ? $_FILES['floor-image-ground-floor']['size'] : 0;
    $floors_images = get_term_meta($term_id,'floors_images',true);
    $floors_images = empty($floors_images) ? [] : $floors_images;
    $rooms_count_per_floor = get_term_meta($term_id,'rooms_count',true);
    $rooms_count_per_floor = empty($rooms_count_per_floor) ? [] : $rooms_count_per_floor;
    $_old_rooms_count_per_floor = $rooms_count_per_floor;
    $old_floors_images =$floors_images;
    $ground_checked = ( !isset($_POST['ground-floor']) && isset($floors_images['ground-floor']) );
    $count_rooms = array_filter($_POST['floor-rooms-count'],'is_numeric');
    for ($i=0; $i < 5 ; $i++) {
        $indice = $i+1;
        if (!isset($_FILES['floor-image-' . $indice . 'st-floor']['size'])){
                if(!empty($floors_images[$indice . 'st-floor'])){
                    delete_desk_meta($floors_images[$indice . 'st-floor']);
                    wp_delete_attachment($floors_images[$indice . 'st-floor'],true);
                    unset($floors_images[$indice . 'st-floor']);
                    unset($rooms_count_per_floor[$indice . 'st-floor']);
                    continue;
                }
            break;
        }
        if(!empty($rooms_count_per_floor[$indice . 'st-floor']) || !empty($count_rooms[$indice.'-floor']))
            $rooms_count_per_floor[$indice . 'st-floor'] = empty($count_rooms[$indice.'-floor']) ? 20 : $count_rooms[$indice.'-floor'];   
        $attachment_id = upload_image($_FILES['floor-image-' . $indice . 'st-floor']);
        if (!$attachment_id)
            continue;
        if(isset($floors_images[$indice . 'st-floor'])){
            $deleted = delete_desk_meta($floors_images[$indice . 'st-floor']);
            if($deleted){
                wp_delete_attachment($floors_images[$indice . 'st-floor'],true);
            }
        }
        $floors_images[$indice . 'st-floor'] = $attachment_id;
        // $rooms_count_per_floor[$indice . 'st-floor'] = empty($count_rooms[$indice.'-floor']) ? 20 : $count_rooms[$indice.'-floor'];   
    }
    
    $ground_floor = 0;
    if( $ground_checked ){
        delete_desk_meta($floors_images['ground-floor']);
        wp_delete_attachment($floors_images['ground-floor'],true);
        unset($floors_images['ground-floor']);
        unset($rooms_count_per_floor['ground-floor']);
    }
    elseif($ground || !empty($count_rooms["ground-floor"])){
        delete_desk_meta($floors_images['ground-floor']);
        wp_delete_attachment($floors_images['ground-floor'],true);
        $rooms_count_per_floor['ground-floor'] = $count_rooms["ground-floor"] ?? 20;
        $attachment_id = upload_image($_FILES['floor-image-ground-floor']);
        if($attachment_id) {
            $floors_images['ground-floor'] = $attachment_id;
            $ground_floor = 1;
        }
        }
        elseif(isset($_POST['ground-floor']) && isset($floors_images['ground-floor']))
        $ground_floor = 1;
    $_floors =[];
    // var_dump($rooms_count_per_floor);die;
    if($_old_rooms_count_per_floor !== $rooms_count_per_floor){
        update_term_meta($term_id,'rooms_count', $rooms_count_per_floor);
    }
    if($floors_images !== $old_floors_images){
        update_term_meta($term_id,'floors_images', $floors_images);
        $_floors['ground-floor']= $ground_floor;
        if (isset($_POST['number-floor'])) {
            unset($floors_images['ground-floor']);
            $_floors['number-floor']= !empty($floors_images) ? count($floors_images): esc_attr($_POST['number-floor']);
        }
        update_term_meta($term_id,'number_floor', $_floors);
    }
}

}

function get_buildings_in_location(){
    if(isset($_POST['action']) && $_POST['action'] == 'get_buildings_in_location' && wp_verify_nonce($_POST['check_availability'], BOOKING_DIRNAME)){
        define('DOING_AJAX', true);
        $id_location = $_POST['location'] ?? '';
        $html = '<option value="0">All buildings</option>';
        if(!empty($id_location)){
            $terms = get_building_in_specifique_city($id_location);
           if (!empty($terms)) {
               foreach ($terms as $term) {
                    $data = ['id'=>$term->term_id,'name'=>$term->name];
                    $data = htmlspecialchars(json_encode($data), ENT_QUOTES, 'UTF-8');
                  $html .= '<option value="'.$data.'">'.$term->name.'</option>';
            }
        }
        else $html ="<option >no buinding in this city</option>";
    }
    echo $html;
    exit;
    }
}

 function add_desks_meta_boxes(){
    // add_meta_box(
    //     'booking_info',
    //     'Booking information',
    //     'display_booking_information',
    //     'desks',
    //     'normal'
    // );
    add_meta_box(
        'gallery_images',
        'Gallery',
        'my_gallery_metabox_callback',
        'desks',
        'normal'
    );
    add_meta_box(
        'long_term_booking',
        'Long Term Booking',
        'long_term_booking_callback',
        'desks',
        'normal'
    );
}

function disable_save( $maybe_empty, $postarr ) {

    $post_id = $postarr['ID'];
    if(get_post_type($post_id) != 'desks' ) return false;
    if(isset($postarr['post_status']) && $postarr['post_status'] == 'auto-draft') return false;
    if(!is_numeric($post_id)) return;
    $building = get_the_terms($post_id,'buildings');
    $building = $building ? $building : ( isset($_POST['tax_input']['buildings']) ? $_POST['tax_input']['buildings'] : '' );
    if( empty($building) || is_wp_error($building) ) {
        // booking_set_error('errors_in_admin_area_edit_posts',"you should select a building");
        remove_all_actions('admin_notices');
        return true;
    }
    $city = get_the_terms($post_id,'location');
    $city = $city ? $city : ( isset($_POST['tax_input']['location']) ? $_POST['tax_input']['location'] : '' );
    if(empty($city) || is_wp_error($city) ){
        booking_set_error('errors_in_admin_area_edit_posts',"you should select a location");
        remove_all_actions('admin_notices');
         return true;
    }
    if( !empty($city[0]->term_id) && !empty($building[0]->term_id) ){
        $position = get_post_meta($post_id, 'office_position',true);
        $floor = isset($position['floor']) ? $position['floor'].' floor' : '';
        $office_details = get_post_meta($post_id, '_desk_details',true);
        $room = isset($office_details['room']) ? $office_details['room'] : '';
        $key_option = $city[0]->term_id.'_'.$building[0]->term_id.'_'.$floor.'_'.$room;
        $is_locked = get_option('locked_rooms',false);
        if(isset($is_locked[$key_option])){
            booking_set_error('errors_in_admin_area_edit_posts',"you can t update the current post , it s locked");
            remove_all_actions('admin_notices');
            return true;
        } 
    }
    return false;
}

function long_term_booking_callback($post){
    if(empty($post)) return;
    include(BOOKING_PLUGIN_DIR.'/includes/templates/template-parts/long-term-booking.php');

}
function my_gallery_metabox_callback($post){
    if(!empty($post)){
    wp_nonce_field( BOOKING_FILENAME, 'gallery_images_nonce' );
    $gallery_images = get_post_meta( $post->ID, 'gallery_images', true );
    $reservations ='<div class="my-gallery-container"><ul class="my-gallery-images">';
        if ( !empty($gallery_images) ) :
            foreach ( $gallery_images as $image_id => $image ) :
                $image = wp_get_attachment_image( $image_id, 'thumbnail' );
                if ( !empty($image) ) :
                    $reservations .='<li>'. $image .'<input type="hidden" name="my-gallery-images[]" value="'. $image_id .'" /><a href="#" class="my-remove-image">&times;</a></li>';
                endif;
            endforeach;
        endif;
    $reservations .='</ul>
    <button id="my-gallery-upload-button" class="button">Add Images</button>
    </div>';


    echo $reservations;
    }
}
function save_post_data($post_id,$post) {
    if($post->post_type != 'desks') return;
    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) 
        return;    
    if (!current_user_can('edit_post', $post_id)) 
        return;
    if(!empty($_POST['year-agreement']['checked'])){
        $billing_details = array_filter($_POST['year-agreement'],'sanitize_text_field') ;
            if(!empty($billing_details['billing_first_name']) && !empty($billing_details['billing_last_name']) &&
                    is_numeric($billing_details['billing_phone']) && is_email($billing_details['billing_email']) && 
                    is_numeric($billing_details['mounth_payement']) && !empty($billing_details['dates-range'])){
                    $city = $billing_details['county']?? '';
                    $dates = str_replace(' - ','-',$billing_details['dates-range']);
                    $dates = explode('-',$dates);
                    $date_start = $dates[0] ;
                    $date_end =  $dates[1] ;
                    $diff_date = get_date_diff($date_start,$date_end);
                    if(!empty($diff_date) && in_array($diff_date,array('366','365')) ){
                        $_POST['calculed_date_year'] = $diff_date;
                        $_POST['mounth_payement'] = $billing_details['mounth_payement'];
                        $date_start = adapte_the_date_format($date_start) ;
                        $date_end = adapte_the_date_format($date_end) ;
                        $check_booking = get_reserved_offices($date_start,$date_end,true);
                        if(!in_array($post_id,$check_booking)){
                            $_desk_type = $_POST['tax_input']['workspace-type'] ?? '';
                            $office_details = get_post_meta($post_id, '_desk_details',true);
                            $floor_office = get_post_meta($post_id, 'office_position',true);
                            if(!empty($office_details['room']) && !empty($office_details['seat']) && !empty($floor_office['floor'])){
                                $_room = $office_details['room'];
                                $_seat = $office_details['seat'];
                                $_floor = is_numeric($floor_office['floor']) ? return_ordinal_number($floor_office['floor']).' Floor' : $floor_office['floor'].' Floor' ;
                                $_items = array(array(
                                    '_ctpost_id'=> $post_id,
                                    '_desk_type' => $_desk_type,
                                    '_floor' => $_floor,
                                    '_room' => $_room,
                                    '_seat' => $_seat,
                                    '_datestart' =>$date_start,
                                    '_dateend' =>$date_end
                                ));

                                global $woocommerce;

                                $billing_details['billing_address_1'] = !empty($billing_details['billing_address_1']) ? $billing_details['billing_address_1'] : '';
                                $billing_details['billing_city'] = !empty($billing_details['billing_city']) ? $billing_details['billing_city'] : '';
                                $billing_details['county'] = !empty($billing_details['county']) ? $billing_details['county'] : '';
                                $address = array(
                                    'first_name' => $billing_details['billing_first_name'],
                                    'last_name'  => $billing_details['billing_last_name'],
                                    'email'      => $billing_details['billing_email'],
                                    'phone'      => $billing_details['billing_phone'],
                                    'address_1'  => $billing_details['billing_address_1'],
                                    'city'       => $billing_details['billing_city'],
                                    'country'    => $billing_details['county'],
                                );
                                // Now we create the order
                                $order = wc_create_order();
                                $oreder_id = $order->get_id();
                                $order->add_product( get_product($post_id)); // This is an existing SIMPLE product
                                $order->set_address( $address, 'billing' );
                                $order->calculate_totals();
                                $order->update_status("Completed", 'Imported order', TRUE);  
                            //   }
                                set_reservation_function($billing_details['billing_first_name'],$billing_details['billing_last_name'],$billing_details['billing_phone'],$billing_details['billing_email'],$city,'',$_items,$oreder_id);  
                                booking_set_error('sucess_in_admin_area_edit_posts','Office booked succefully between  '.$date_start.' '.$date_end);
                            }
                            else{
                                $term_buil = get_term_by('name', $_POST['tax_input']['buildings'], 'buildings');
                                $tag_ID = $term_buil ? $term_buil->term_taxonomy_id : '';
                                $link ='<a href=/wp-admin/term.php?taxonomy=buildings&tag_ID='.$tag_ID.'&post_type=desks" target="_blank"> manage office position</a>';
                                booking_set_error('year-agreement-error','Office not affect yet please visit this link'.$link);    
                            }
                        }
                        else {
                            booking_set_error('year-agreement-error','this Office Already reserved in '.$date_start.' '.$date_end);    
                            booking_set_error('errors_in_admin_area_edit_posts','this Office Already reserved in '.$date_start.' '.$date_end);    
                        }
                    }
                    else
                        booking_set_error('year-agreement-error','Please date range should be a year');                    
                }
                else{
                        booking_set_error('year-agreement-error','please fill the required fields with the correct mail and phone number');
                }
    }
    if (!isset($_POST['gallery_images_nonce']) || !wp_verify_nonce($_POST['gallery_images_nonce'], BOOKING_FILENAME)) 
        return;
    if(empty($_POST['tax_input']) || empty($_POST['tax_input']['location']) || empty($_POST['tax_input']['workspace-type']) || empty($_POST['tax_input']['buildings'])){
        remove_action('save_post', 'save_post_data');
        wp_update_post(array('ID' => $post_id, 'post_status' => 'draft'));  
        add_action('save_post', 'save_post_data');
    }
    $arrGallery = !empty($_POST['my-gallery-images']) ? $_POST['my-gallery-images'] : [];
    $arrGallery = array_filter($arrGallery,'is_numeric');
    if (!empty($arrGallery)){
        $gallery_url=[];
        foreach ($arrGallery as $id_attachement) {
            $gallery_url[$id_attachement] = wp_get_attachment_image_url($id_attachement, 'full');
        }
        $arrGallery = $gallery_url;
    }
    update_post_meta($post_id, 'gallery_images', $arrGallery);
}









function display_booking_information($post){
    if(!empty($post)){
        $Date_reservations = get_post_meta($post->ID,'Date_reservation',true);
        $reservations ='<h3> No reservation disponible </h3>';
        if(!empty($Date_reservations)){
            $reservations = '
            <table id="list-table">
                <tbody id="the-list" data-wp-lists="list:meta">
                    <tr>
                        <td class="left">
                            <label class="" for="">Reservations Date</label>
                        </td>
                        <td>
                            <select>';


                                foreach($Date_reservations as $dr){
                                    $dr = str_replace('_',' to ', $dr);
                                    $reservations .= '<option>
                                    from '.$dr.'
                                </option>';
                                }


            $reservations .= '</select>
                        </td>
                    </tr>
                </tbody>
        </table>';
        }
        echo $reservations ;
    }
}

function lw_add_to_cart_redirect() {
 global $woocommerce;
 $lw_redirect_checkout = $woocommerce->cart->get_checkout_url();
 return $lw_redirect_checkout;
}


function woocommerce_data_stores ( $stores ) {
    if( !class_exists('WCCPT_Product_Data_Store_CPT') )
        include(BOOKING_PLUGIN_DIR.'/includes/classes/WCCPT_Product_Data_Store_CPT.php');
	$stores['product'] = 'WCCPT_Product_Data_Store_CPT';
	return $stores;
}

function woocommerce_product_get_price( $price, $product ) {
    $id_desk =  !empty($_POST['product_id']) ? $_POST['product_id'] : $product->get_id();
    $pst =  get_post_type($id_desk);
    if($pst != 'desks')  return;
    $totale_days = isset($_POST['totale_days']) ? $_POST['totale_days'] : 
                    (isset($_POST['calculed_date_year']) ? $_POST['calculed_date_year'] :'');
    $price_per_day = isset($_POST['mounth_payement']) && isset($_POST['calculed_date_year']) 
                    ? ($_POST['mounth_payement']*12)/$_POST['calculed_date_year'] : '';
    if(empty($totale_days)){
        global $woocommerce;
        if(isset($woocommerce->cart)){
            $items = $woocommerce->cart->get_cart();
            if(!empty($items)){
                $date_start = '';
                $date_end = '';
                foreach( $items as $cart_item ){
                    if($id_desk == $cart_item['product_id']){
                        $date_start = $cart_item['datestart'];
                        $date_end = $cart_item['dateend'];
                        break;
                    }
                }            
                $totale_days = get_date_diff($date_start,$date_end);
            }
        }
    }

    if ( empty($totale_days) ) return ;

    $desk_type = get_the_terms($id_desk,'workspace-type')[0];
    $desk_type_slug = isset($desk_type->slug) ? $desk_type->slug : '';
    $price = (!empty($desk_type_slug) ) ? calcul_price_per_days($totale_days,$id_desk,$desk_type_slug,$price_per_day) : 0;

    return $price;
}

function change_class_post_item($cls,$where){
    if($where == 'find_desks'){
        global $desks_position;
        $cls = 'col-xs-12 position-'.$desks_position;
    }
    return $cls;
}

function change_class_post_item_image($cls,$where){
    if($where == 'find_desks'){
        $cls = 'col-xs-12 col-sm-4';
    }
    return $cls;
}

function change_class_post_item_body($cls,$where){
    if($where == 'find_desks'){
        $cls = 'col-xs-12 col-sm-8';
    }
    return $cls;
}


function remove_some_item_in_menu() {
    $roles = get_the_user_roles();
    if( in_array('booking-member',$roles) ){
        global $menu;
        $menu_slug = array('Booking Desks','WooCommerce');
        foreach ( $menu as $i => $item ) {
            if ( !in_array($item[0],$menu_slug) ) {
                unset( $menu[ $i ] );
            }
        }
    }
}


// Hook in


// Our hooked in function - $fields is passed via the filter!
function custom_override_checkout_fields( $fields ) {
    //  unset($fields['order']['order_comments']);
  
    $fields = $fields['billing'];
    foreach ($fields as $k => $v) {
        if(in_array($k, array('billing_first_name','billing_last_name',/*'billing_state',*/'billing_postcode','billing_city','billing_address_1','billing_phone','billing_email',))){

            continue;
        }
        unset($fields[$k]);
    }

    $fields = array('billing'=>$fields) ;

    $fields['billing']['country'] = array(
            'label'       => 'Country',
            'placeholder' => 'Enter your country',
            'required'    => false,
            'priority'    => 75,
            'type'        => 'text',
            'class'       => array('input-text'),
        );
      
    return $fields;
}


//add checkbox rgpd to checkout page
function accept_rgpd() {
    echo '<p class="form-row terms">
    <input type="checkbox" class="input-checkbox" name="accept-rgpd" id="accept-rgpd">
    <label for="accept-rgpd" class="checkbox">I have read and accept the <a href="/privacy-policy">privacy policy*</a></strong></label> 
    </p>';
}
function accept_rgpd_erreur() {
    if (!isset( $_POST['accept-rgpd'] )) {         
        wc_add_notice( __( '<strong>You must accept the <a href="/privacy-policy">privacy policy</a></strong>' ), 'error' );     
    } 
}


//add login  to checkout page
function display_login_form_on_checkout() {
    if ( !is_user_logged_in() ) {
        $login_url = wp_login_url( get_permalink() );
        ?>
        <div class="checkout-login-form">
            <h2 class="login-heading"><?php _e( 'Please choose how you want to proceed', 'text-domain' ); ?></h2>
            <!-- <p><?php _e( 'Welcome to innovarooms.', 'text-domain' ); ?></p> -->
            <div class="container">
                <div class="login-method-buttons">
                    <button class="guest-checkout-btn">Guest Checkout</button>
                    <button class="login-btn active">Log In</button>
                </div>
                <div class="guest-login">
                    <p>You do not need an account to checkout</p>
                    <button>Continue as Guest</button>
                    <div class="guest-register">
                    <p>Create an account for faster checkout </p>
                    <?php 
                        $checkout_url = wc_get_checkout_url();
                        $checkout_url = str_replace([get_site_url(),'/'],'',$checkout_url);
                    ?>
                    <a href="<?php echo site_url('/wp-login.php?action=register&page='.$checkout_url);?>"><?php _e( 'Sign up', 'text-domain' ); ?></a>
                </div>
                </div>
                <div class="login">
                    <form name="login-form" id="login-form" action="<?php echo esc_url( $login_url ); ?>" method="post">
                        <div class="form-row form-row-wide">
                            <label for="username"><?php _e( 'Username or email address', 'text-domain' ); ?>&nbsp;<span class="required">*</span></label>
                            <input type="text" class="input-text" name="log" id="username" value="" required>
                        </div>
                        <div class="form-row form-row-wide">
                            <label for="password"><?php _e( 'Password', 'text-domain' ); ?>&nbsp;<span class="required">*</span></label>
                            <input type="password" class="input-text" name="pwd" id="password" value="" required>
                            <div class="lost_password">
                            <a href="<?php echo esc_url( wp_lostpassword_url() ); ?>"><?php _e( 'Forgot password?', 'text-domain' ); ?></a>
                        </div>
                        </div>
                        <div class="form-row">
                            <input type="submit" class="button" name="login" value="<?php _e( 'Log in', 'text-domain' ); ?>">
                        </div>
                        
                    </form>
                    <div class="register">
                    <p>Don't have an account? </p>
                    <?php 
                        $checkout_url = wc_get_checkout_url();
                        $checkout_url = str_replace([get_site_url(),'/'],'',$checkout_url);
                    ?>
                    <a href="<?php echo site_url('/wp-login.php?action=register&page='.$checkout_url);?>"><?php _e( 'Sign up', 'text-domain' ); ?></a>
                </div>
                </div>
                <!-- <div class="line">Or</div> -->

                
                <div class="contact-us">
                    <p>Need some help? </p><a href="#">Contact us</a>
                </div>
            </div>
        </div>
        <?php
    }
}


//auto login after registration
function auto_login_after_registration( $user_id ) {
    if( $_POST['_page'] == 'checkout' ){
        $curent_user = wp_set_current_user( $user_id );
        $curent_user->set_role('booking-member');
        if ( isset($_POST['user_password']) && isset($_POST['confirm_user_password']) && $_POST['user_password'] === $_POST['confirm_user_password'] ){
            wp_set_password( $_POST['user_password'], $user_id );
        } 
        setcookie('regiter_from_checkout', null, strtotime('-1 day'));
        wp_set_auth_cookie( $user_id, true, false );
        wp_redirect( '/'.$_POST['_page'] );
        exit;
    }
}


function change_return_to_cart_url() {
    return '/';
}



function change_postcode_local_label( $array ){

    $array['US']['postcode']['label'] = 'Eircode';
    //$array['US']['state']['label'] = 'County';

    return $array;
}


function woo_locate_template_in_plugin( $template, $template_name, $template_path ) {

    global $woocommerce;

    $_template = $template;
    if ( ! $template_path )
        $template_path = $woocommerce->template_url;

    $plugin_path  = BOOKING_PLUGIN_DIR . '/includes/woocommerce/templates/';

    if( file_exists( $plugin_path . $template_name ) )
        $template = $plugin_path . $template_name;

    if ( ! $template )
        $template = $_template;

    return $template;
}


function custom_add_to_cart_handler() {

    if( isset($_POST['product_id']) && get_post_type($_POST['product_id'])== 'desks' ) { 

        $is_locked = get_option('locked_rooms',false);
        if($is_locked){
            $city = $_POST['city'];
            $id_builidng = $_POST['building'];
            $floor = $_POST['floor_indice'];
            $room = $_POST['room'];
            $key_part_floor = $floor.'st';
            if($floor == 'ground') $key_part_floor ='ground';
            $key_part_floor .=' floor';
            if($is_locked && isset($is_locked[$city.'_'.$id_builidng.'_'.$key_part_floor.'_'.$room])) {
                wc_add_notice(
                    "this room is locked"
                ,'notice' );
                wc_print_notices(); // Return printed notices to jQuery response.
                wp_die();
            }
        }

        if ( ! WC()->cart->is_empty() ) {
            $in_cart = false;
            foreach( WC()->cart->get_cart() as $cart_item ) {
                if ( $cart_item['data']->get_id() == $_POST['product_id'] ) {
                    $in_cart = true;
                    break;
                }
            }
            if($in_cart){
                wc_add_notice(
                    'Product Already added to cart
                    <a href="'.esc_url(wc_get_cart_url()).'" class="costum-proceed-to-cart">
	                Proceed to cart</a>' 
                ,'notice' );
                wc_print_notices(); // Return printed notices to jQuery response.
                wp_die();
            }
        }
        
        $date_start = $_POST['datestart'];
        $date_end = $_POST['dateend'];
        $_date_start = seperate_date_time($date_start);
        $_date_end = seperate_date_time($date_end);
        if(empty($_date_start[1])) $date_start.=' 07:00';
        if(empty($_date_end[1])) $date_end.=' 19:00';
        $date_start = adapte_the_date_format($date_start);
        $date_end = adapte_the_date_format($date_end);
        if( empty($date_start) || empty($date_end) ) {
            wc_add_notice(
                "Please Check different dates"
            ,'error' );
            wc_print_notices(); // Return printed notices to jQuery response.
            wp_die();
        };
        $_POST['datestart'] = $date_start;
        $_POST['dateend'] = $date_end;
        $product_id = $_POST['product_id'];
         // Initializing
        $variation_id = 0;
        $product = wc_get_product( $variation_id ? $variation_id : $product_id );
        $reserved_offices = get_reserved_offices($_POST['datestart'],$_POST['dateend'],true) ;
        if(!empty($reserved_offices) && in_array($product_id,$reserved_offices)){
            wc_add_notice(
                $product->get_name().
                " has been purchased already"
            ,'error' );
            wc_print_notices(); // Return printed notices to jQuery response.
            wp_die();
        }
        $variation = $cart_item_data = $custom_data = array(); // Initializing
        // Allow product custom fields to be added as custom cart item data from $custom_data additional array variable
        $cart_item_data = (array) apply_filters( 'woocommerce_add_cart_item_data', $cart_item_data, $product_id, $variation_id, 1 );

        // Add to cart
        $cart_item_key = WC()->cart->add_to_cart( $product_id, 1, $variation_id, $variation, $cart_item_data );

        if ( $cart_item_key ) {
            // Add to cart successful notice
            //wc_add_notice( sprintf(
                //'<a href="%s" class="button wc-forward">%s</a> "%s" %s' ,
                //wc_get_cart_url(),
                //__("View cart", "woocommerce"),

                //$product->get_name(),
               //__("has been added to your cart", "woocommerce")
            //) );
            echo "true";die;
        }

        wc_print_notices(); // Return printed notices to jQuery response.
        wp_die();
    }
}


function custom_default_address_fields( $address_fields ) {
    if ( is_checkout() ) {

        $address_fields['address_1']['label'] = __('Address', 'woocommerce');
        $address_fields['postcode']['label'] = 'Eircode';
        $address_fields['city']['label'] = 'Town';
        //$address_fields['state']['label'] = 'County';

        $address_fields['state']['type'] = 'text';
        $address_fields['postcode']['required'] = false;

    }
    return $address_fields;
}

/** Remove product data tabs */


function my_remove_product_tabs( $tabs ) {
    unset( $tabs['additional_information'] ); // To remove the additional information tab
  return $tabs;
}



function dashboard_redirect($url, $request, $user) {
    if (!empty($user->roles) && in_array('booking-member',$user->roles) ) {
        $url = esc_url( admin_url( 'admin.php?page=bookings' ) );
    }
    return $url;
}

function customize_my_wp_admin_bar( $wp_admin_bar ) {
    if(!is_admin() && current_user_can('public_data')){
        $nodes = array('site-name','dashboard');
        foreach($nodes as $node){
            $site_node = $wp_admin_bar->get_node($node);
            if(empty($site_node)) continue;
            $site_node->href = esc_url( admin_url( 'admin.php?page=bookings' ) );
            $wp_admin_bar->add_node($site_node);
        }
    }

}


function create_api_posts_meta_field() {

    register_rest_field( 'desks', 'Date_reservation', array(
           'get_callback'    => 'get_post_meta_for_api',
           'schema'          => null,
        )
    );

    register_rest_field( 'buildings', 'city_of_building', array(
        'get_callback'    => 'get_tax_meta_for_api',
        'schema'          => null,
     )
 );

}

function get_post_meta_for_api( $object ) {
    //get the id of the post object array
    $post_id = $object['id'];

    //return the post meta
    return get_post_meta( $post_id,'Date_reservation');
}

function get_tax_meta_for_api($object){
    //get the id of the post object array
    $post_id = $object['id'];
    //return the post meta
    $city = get_term_meta( $post_id,'city_of_building');
    return $city;
}


function add_custom_cart_item_data( $cart_item_data, $product_id, $variation_id ){
    if( isset($_POST['product_id'])  && isset( $_POST['datestart'] ) && isset( $_POST['dateend'] ) ) {
        $cart_item_data['ctpost_id'] = wc_clean( $_POST['product_id'] );
        $cart_item_data['datestart'] = wc_clean( $_POST['datestart'] );
        $cart_item_data['dateend'] = wc_clean( $_POST['dateend'] ); 
        $cart_item_data['room'] = wc_clean( $_POST['room'] ); 
        $cart_item_data['seat'] = wc_clean( $_POST['seat'] ); 
        $cart_item_data['desk_type'] = wc_clean( $_POST['desk_type'] ); 
        $cart_item_data['floor'] = wc_clean( $_POST['floor'] ); 
        $cart_item_data['city'] = wc_clean( $_POST['city'] );
    }
    return $cart_item_data;
}



function save_cpt_id_to_order_item_data( $item, $cart_item_key, $cart_item, $order ){
    if( $cart_item['ctpost_id'] && !empty($cart_item['ctpost_id']) ) {
        // Add the custom CTP post ID
        $item->add_meta_data('_ctpost_id', $cart_item['ctpost_id'] );
        $item->add_meta_data('_datestart', $cart_item['datestart'] );
        $item->add_meta_data('_dateend', $cart_item['dateend'] );
        $item->add_meta_data('_room', $cart_item['room'] );
        $item->add_meta_data('_seat', $cart_item['seat'] );
        $item->add_meta_data('_desk_type', $cart_item['desk_type'] );
        $item->add_meta_data('_floor', $cart_item['floor'] );
        $item->add_meta_data('_city', $cart_item['city'] );
    }

}




function set_etat_reservation_payement_woocomerce($order_id){
    
    if ( ! $order_id ) return;

    $_order_exist = check_row_exist('booking_info','order_id',$order_id);
    if ($_order_exist)
        return;

    $order = wc_get_order( $order_id );
    $data = $order->get_data();
    $order_billing = $data['billing'];
    $order_items = $data['line_items'];
    if (empty($order_items))
        return;

    set_reservation_function($order_billing['first_name'],$order_billing['last_name'],
                            $order_billing['phone'],$order_billing['email'],$order_billing['city'],$data['status'],$order_items,$order_id);
}


function wpdocs_add_new_buildings_columns( $columns ) {
    $columns['city'] = __( 'City' );
    $columns['floor'] = __( 'Floor' );
    return $columns;
}

function wpdocs_show_buildings_meta_info_in_columns( $string, $columns, $term_id ) {
    switch ( $columns ) {
        // in this example, we had saved some term meta as "genre-characterization"
        case 'city':
            $id_city = get_term_meta($term_id, 'city_of_building', true);
            $term = get_term($id_city,'location');
            $city_name = (!empty($term) && !is_wp_error($term)) ? $term->name : '';
            echo esc_html($city_name);
        break;
        case 'floor':
            $number_floor = get_term_meta($term_id, 'number_floor', true);
            $result = '';
            if(isset($number_floor['number-floor']) && $number_floor['number-floor'] ) $result .= $number_floor['number-floor'];
            if(isset($number_floor['ground-floor']) && $number_floor['ground-floor'] && !empty($result)) $result .= ' + ground floor';
            elseif( isset($number_floor['ground-floor']) && $number_floor['ground-floor'] ) $result .= 'ground floor';
            echo esc_html($result);
        break;
    }
}

function show_admin_notices() {

    if( (!empty($_GET['post']) && isset($_GET['action']) && $_GET['action'] == 'edit') || (isset($_GET['page']) && $_GET['page'] == 'cleaner')){
        $error = booking_show_error('errors_in_admin_area_edit_posts');
        $succes = booking_show_error('sucess_in_admin_area_edit_posts');
        $class ='';
        $text_message ='';
        if($error){
            $class = 'notice-error';
            $text_message = $error;
        }
        elseif($succes){
            $class = 'notice-success';  
            $text_message = $succes;
        }
        if(!empty($text_message)){
            $html =  '<div class="notice '.$class.' ">
                                    <p>
                                        '.$text_message.'
                                    </p>
                                </div>';
            echo $html ;      
        }
    }
}

add_filter('post_updated_messages',function($messages){

    if( !empty($_GET['post']) && isset($_GET['action']) == 'edit' && get_post_type($_GET['post']) == 'desks' ){
        $error = booking_show_error('errors_in_admin_area_edit_posts');
        if($error)
            return ;
    }
    return $messages;
});
function add_fields_to_resister_form(){

    if( !empty($_GET['page']) || (isset($_COOKIE['regiter_from_checkout']) && $_COOKIE['regiter_from_checkout'] == 'true') ){
        if( !isset($_GET['page']) ){
            $_GET['page'] = wc_get_checkout_url();
            $_GET['page'] = str_replace([get_site_url(),'/'],'',$_GET['page']);
        }
        if(!isset($_COOKIE['regiter_from_checkout'])){
            setcookie('regiter_from_checkout','true', strtotime("+10 minutes"));
        }
        
        echo '<p><label for="user_password">Password</label>
				<input type="password" name="user_password" id="user_password" class="input" size="25">
			</p>
            <p><label for="confirm_user_password">Confirm password</label>
				<input type="password" name="confirm_user_password" id="confirm_user_password" class="input" size="25">
			</p>
            <p><input type="hidden" name="_page"   value="'.$_GET['page'].'"></p>';
    }
}
add_action('login_footer',function(){
    echo '
    <script> 
    const element = document.getElementById("reg_passmail");
    element.remove();
    </script>
    ';
});
add_filter('registration_errors',function ($errors){
    if(!empty($_POST['user_password']) && ($_POST['user_password'] == $_POST['confirm_user_password'])) {
        $password = $_POST['user_password'];
        $cpassword = $_POST['confirm_user_password'];
        $sanitized_password = sanitize_text_field($password);
        if($password != $sanitized_password){
            $passwordErr = "Your Password has an incorrect format!";
        }
        elseif (strlen($_POST['user_password']) <= '8') {
            $passwordErr = "Your Password Must Contain At Least 8 Characters!";
        }
        elseif(!preg_match("#[0-9]+#",$password)) {
            $passwordErr = "Your Password Must Contain At Least 1 Number!";
        }
        elseif(!preg_match("#[A-Z]+#",$password)) {
            $passwordErr = "Your Password Must Contain At Least 1 Capital Letter!";
        }
        elseif(!preg_match("#[a-z]+#",$password)) {
            $passwordErr = "Your Password Must Contain At Least 1 Lowercase Letter!";
        }
    }
    elseif(!empty($_POST['user_password'])) {
        $passwordErr = "Please Check You've Entered Or Confirmed Your Password!";
    } elseif(!empty($_POST['_page']) && empty($_POST['user_password'])) {
         $passwordErr = "Please enter password   ";
    }

    if(isset($passwordErr)){
        $errors->add( 'password_error', __( '<strong>ERROR</strong>: '.$passwordErr, 'my_textdomain' ) );
    }

    return $errors;
});
function remove_filtre_by_user() {
    $roles = get_the_user_roles();
    if(in_array('booking-member',$roles)){
        global $wc_list_table;
        if ( $wc_list_table instanceof WC_Admin_List_Table_Orders ) {
            remove_action( 'restrict_manage_posts', array( $wc_list_table, 'restrict_manage_posts' ) );
        }
    }
}

function schedule_routine_check(){
    if ( ! wp_next_scheduled( 'check_routine_status' ) ) {
        wp_schedule_event( time(),'every_hour', 'check_routine_status' );
    }
}
function check_routine_status() {
// $activation_check_interval = 60;
$activation_check_url = 'https://futuredata.ie/apis/check-activation.php';

$activation_code = get_option('_activation_code');
$domain_name = $_SERVER['SERVER_NAME']; 
        $response = wp_remote_post($activation_check_url, array(
            'timeout' => 5,
            'sslverify' => true,
            'body' => array(
                'activation_code' => $activation_code,
                'domain_name' => $domain_name
            ),
        ));
        if (!is_wp_error($response)) {
            $status = $response['body'];
            if ($status !== 'valid') {
                deactivate_plugins(BOOKING_BASENAME);
            }
        }
}

add_filter( 'cron_schedules', 'isa_add_every_two_minutes' );
function isa_add_every_two_minutes( $schedules ) {
    $schedules['every_hour'] = array(
            'interval'  => 60 * 60,
            'display'   => __( 'Every hour', 'textdomain' )
    );
    return $schedules;
}
function redirect_admin_dashboard() {
    if ( is_admin() && in_array('innova-manager',get_the_user_roles()) && strtolower($_SERVER['REQUEST_URI']) == '/wp-admin/' ) {
        wp_redirect(  site_url('/wp-admin/admin.php?page=bookings') );
        exit;
    }
}

function disable_autosave() {
    $current_roles = get_the_user_roles();
    if($current_roles && in_array('innova-manager',$current_roles))
        wp_deregister_script('autosave');
}

function empty_cart_redirection(){
    if( is_cart() ) :
    $url_redirection = esc_url( home_url( '/' ) );

    if( WC()->cart->is_empty() ){
        wp_safe_redirect( $url_redirection );
        exit();
    }
    wc_enqueue_js( "jQuery(function($){
        $(document.body).on( 'wc_cart_emptied', function(){
            if ( $( '.woocommerce-cart-form' ).length === 0 ) {
                $(window.location).attr('href', '" . $url_redirection . "');
                return;
            }
        });
    });" );
    endif;
}

/**
 * @snippet       Add Inline Field Error Notifications @ WooCommerce Checkout
 * @how-to        Get CustomizeWoo.com FREE
 * @author        Rodolfo Melogli
 * @compatible    WooCommerce 5
 * @community     https://businessbloomer.com/club/
 */
 
 add_filter( 'woocommerce_form_field', 'custom_checkout_fields_error_validation', 10, 4 );
 
 function custom_checkout_fields_error_validation( $field, $key, $args, $value ) {
    if ( strpos( $field, '</span>' ) !== false && $args['required'] ) {
       $error = '<span class="error" style="display:none">';
       $error .= sprintf( __( '<strong>%s</strong> is a required field.', 'woocommerce' ), $args['label'] );
       $error .= '</span>';
       $field = substr_replace( $field, $error, strpos( $field, '</span>' ), 0);
    }
    return $field;
 }