<?php



function prase_date_to_date_Time($date_start, $date_end) {
    $_date_start = seperate_date_time($date_start);
    $_date_end = seperate_date_time($date_end);

    if (empty($_date_start[1]) && $_date_start[0] == date('d/m/Y')) {
        $date_start .= ' ' . date('H:i', strtotime('+1 hour'));


    } elseif (empty($_date_start[1])) {
        $date_start .= ' 07:00';

    }

    if (empty($_date_end[1])) {
        $date_end .= ' 19:00';
    }

    return [$date_start, $date_end];
}


function prase_time_to_date_Time($time){

    if(!preg_match("/^(?:2[0-3]|[01][0-9]):[0-5][0-9]$/", $time)) return false;

     return date('Y-m-d').' '.$time;



}

function get_reserved_offices($date_start,$date_end ,$is_date_in_correct_foramt = false,$args = array(),$include_boocking_type = true) {

    $dates_time = prase_date_to_date_Time($date_start,$date_end);

    $date_start = $dates_time[0];

    $date_end =$dates_time[1];

    if(!$is_date_in_correct_foramt){

        $date_start = adapte_the_date_format($date_start);

        $date_end = adapte_the_date_format($date_end);

    }       

    

    if( empty($date_start) || empty($date_end) ) return ;

    $condition = "";

    $boocking_type_condition = "";

    if(!empty($args['floor']))

        $condition = " floor = "."'".$args['floor']."' AND ";



    global $wpdb;

    $tablename = $wpdb->prefix . 'booking_info';



    if($include_boocking_type)

        $boocking_type_condition = "booking_type = 'booking' AND";

    $reserved_desks_query = "SELECT desk_id FROM `$tablename` WHERE $boocking_type_condition   $condition

        (

            ( '$date_start'  BETWEEN  date_start AND date_end ) 

            OR ( '$date_end' BETWEEN  date_start AND date_end ) 

            OR ( '$date_start' < date_start AND '$date_end' > date_end ) 

        ) 

        GROUP BY desk_id";

    $return = $wpdb->get_results($reserved_desks_query,ARRAY_A);

    if(empty($return)) return $return;

    $return = array_column($return,'desk_id');

    return $return;



}



function get_the_user_roles(){

    $current_user = wp_get_current_user();

    if ( empty( $current_user->roles ) || !is_array( $current_user->roles ) ) 

        return [];

    return $current_user->roles;

}



function upload_image($file){

    if ($file['size']){

        $sideload = wp_handle_sideload($file,array('test_form' => false));

        if( ! empty( $sideload[ 'error' ] ) ) 

            return false;

        $attachment_id = wp_insert_attachment(

                                                array(

                                                    'guid'           => $sideload[ 'url' ],

                                                    'post_mime_type' => $sideload[ 'type' ],

                                                    'post_title'     => basename( $sideload[ 'file' ] ),

                                                    'post_content'   => '',

                                                    'post_status'    => 'inherit',

                                                ),

                                                $sideload[ 'file' ]

                                            );



        if( is_wp_error( $attachment_id ) || ! $attachment_id ) 

            return false;

        require_once( ABSPATH . 'wp-admin/includes/image.php' );

        wp_update_attachment_metadata(

            $attachment_id,

            wp_generate_attachment_metadata( $attachment_id, $sideload[ 'file' ] )

        );

            

        return $attachment_id;

        

    }              



}



function delete_desk_meta($id_plan=null,$desk_id = null){

    $return = false;

    if(empty($id_plan) && empty($desk_id)) return;

    if(isset($desk_id)){

        $res_delt_desk_details = delete_post_meta($desk_id,'_desk_details');

        $res_delt_max_people = delete_post_meta($desk_id,'_max_people');  

        $res_delt_office_position = delete_post_meta($desk_id, 'office_position');

        $res_delt_office_floor_plan = delete_post_meta($desk_id, 'office_floor_plan');

        $res_delt_office_room = delete_post_meta($desk_id, '_room');

        $res_delt_office_floor = delete_post_meta($desk_id, '_floor');

        $return = $res_delt_desk_details && $res_delt_max_people && $res_delt_office_position &&

                     $res_delt_office_floor_plan && $res_delt_office_room && $res_delt_office_floor;

    }

    elseif(isset($id_plan)){

        $posts_ids = get_posts(array(

            'post_type'              => 'desks',

            'fields'                 => 'ids',

            'meta_query'             => array(

                array(

                    'key'       => 'office_floor_plan',

                    'value'     => $id_plan,

                ),

            ),

        ));

        foreach ($posts_ids as $id) {

            $res_delt_desk_details = delete_post_meta($id,'_desk_details');

            $res_delt_max_people = delete_post_meta($id,'_max_people');

            $res_office_position = delete_post_meta($id,'office_position');

            $res_office_floor_plan = delete_post_meta($id,'office_floor_plan');

            $res_office_floor = delete_post_meta($id,'_floor');

            $res_office_room = delete_post_meta($id,'_room');

            

        }

        $return = $res_office_position && $res_office_floor_plan && $res_office_floor && $res_office_room;

    }



    return $return;

}

function calcul_price_per_days($totale_days, $office, $slug_desk_type, $price = '') 
{
    if (!empty($price)) {
        $price_per_day = $price;
    } else {
        $desk_details = get_post_meta($office, '_desk_details', true);
        if (!empty($desk_details['price'])) {
            $price_per_day = $desk_details['price'];
        } else {
            $price_options = get_option('desks_price_settings');
            if (($slug_desk_type == 'meeting-training-room-long-table' || $slug_desk_type == 'meeting-training-room-round-table') && ($totale_days == 0.5)) {
                $price_per_day = !empty($price_options[$slug_desk_type]['halfday']) ? $price_options[$slug_desk_type]['halfday'] : 0;
            } elseif (($slug_desk_type == 'meeting-training-room-long-table' || $slug_desk_type == 'meeting-training-room-round-table') && $totale_days < 1) {
                $price_per_day = !empty($price_options[$slug_desk_type]['hour']) ? $price_options[$slug_desk_type]['hour'] : 0;
            } elseif ($totale_days < 5) {
                $price_per_day = !empty($price_options[$slug_desk_type]['day']) ? $price_options[$slug_desk_type]['day'] : 0;
            } else {
                $price_per_day = !empty($price_options[$slug_desk_type]['week']) ? $price_options[$slug_desk_type]['week'] : 0;
            }
        }
    }

    $price_per_day = is_numeric($price_per_day) ? $price_per_day : 0;

    if (($slug_desk_type == 'meeting-training-room-long-table' || $slug_desk_type == 'meeting-training-room-round-table') && ($totale_days == 0.5 )) {
        $totale_days = 1;
    } elseif (($slug_desk_type == 'meeting-training-room-long-table' || $slug_desk_type == 'meeting-training-room-round-table') && $totale_days < 1) {
        $totale_days = round($totale_days * 12);
    } elseif (($slug_desk_type == 'meeting-training-room-long-table' || $slug_desk_type == 'meeting-training-room-round-table') && $totale_days < 1) {
        $totale_days = 1;
    }

    $price_without_vta = calc_price($totale_days, 0, $slug_desk_type);

    return $price_without_vta;
}

function calc_price($total_days, $total_price = 0, $slug_desk_type)
{
    $price_options = get_option('desks_price_settings');
    if ($total_days == 0) {
        return $total_price;
    }

    if ($total_days >= 30) {
        $total_price += isset($price_options[$slug_desk_type]['month']) ? $price_options[$slug_desk_type]['month'] : 0;
        $total_days -= 30;
        return calc_price($total_days, $total_price, $slug_desk_type);
    } elseif ($total_days >= 7) {
        $total_price += isset($price_options[$slug_desk_type]['week']) ? $price_options[$slug_desk_type]['week'] : 0;
        $total_days -= 7;
        return calc_price($total_days, $total_price, $slug_desk_type);
    } elseif ($total_days >= 4) {
        $total_price += isset($price_options[$slug_desk_type]['week']) ? $price_options[$slug_desk_type]['week'] : 0;
        $total_days = 0;
        return calc_price($total_days, $total_price, $slug_desk_type);
    } else {
        $total_price += isset($price_options[$slug_desk_type]['day']) ? ($total_days * $price_options[$slug_desk_type]['day']) : 0;
        return $total_price;
    }
}





function get_date_diff($date_start,$date_end,$hour_in_day=12){

    if(!check_date_input($date_start) || !check_date_input($date_end)) return ;

    $date_start_time = strtotime(str_replace('/', '-', $date_start));

    $date_end_time = strtotime(str_replace('/', '-', $date_end));

    $diff_date = $date_end_time - $date_start_time;

    $working_secondes = (60 * 60 * $hour_in_day);

    $count_half_days = $diff_date / $working_secondes;

    $total_days = $count_half_days;

    if($count_half_days > 1){

        $count_days = 0;

        for ($i=0; $i < $count_half_days; $i++) {

                if(  $i%2 == 0  ){

                    $count_days++;

                }

        }

        $total_days = $count_days;

    }

    $number_days = round($total_days, 2);

    $number_days = $number_days ? $number_days : 1 ;

    return $number_days; 

}



function insert_into_db($table_name,$data){

    global $wpdb;

    $tablename = $wpdb->prefix . $table_name;   

        $row_id = 0;

        if(!empty($data)){

            $insert = $wpdb->insert($tablename, $data);

            $row_id = $wpdb->insert_id;

        }

    return $row_id;

}



function check_row_exist($table,$column,$value){

    $table = sanitize_text_field($table);

    $column = sanitize_text_field($column);

    $value = sanitize_text_field($value);

    if (empty($table) || empty($column) || empty($value))

        return;

        

    global $wpdb;

    $tablename = $wpdb->prefix . $table;

    $client_data = $wpdb->get_results("SELECT * FROM " . $tablename . " where  $column = '$value' ");

    if(!$wpdb->num_rows) return $wpdb->num_rows;

    return $client_data;

}

function get_last_cleaning_date($location,$building,$floor,$room,$cleaner=null){

    $floor = get_floor_from_string($floor);

    if ( empty($room) || empty($floor) || empty($location) || empty($building) )

        return;

        $offices_id = get_posts(array(

            'post_type'=>'desks',

            'posts_per_page'=>-1,

            'fields' => 'ids',

            'tax_query' => array(

                'relation' => 'AND',

                array(

                    'taxonomy' => 'location',

                    'field'    => 'term_id',

                    'terms'    => $location

                ),

                array(

                    'taxonomy' => 'buildings',

                    'field'    => 'term_id',

                    'terms'    => $building

                )

            ),

            'meta_query' => array(

                'relation' => 'AND',

                array(

                    'key'   => '_floor',

                    'value' => $floor,

                ),

                array(

                    'key'   => '_room',

                    'value' => $room,

                )

            )

        )); 

    if(empty($offices_id)) return false;



    $offices_id = implode(',',$offices_id);

    global $wpdb;

    $tablename = $wpdb->prefix . 'booking_info';

    $cleaner_sql_part = '';

    if(!empty($cleaner))

        $cleaner_sql_part = " AND cleaner_id = $cleaner ";

    $sql ="SELECT date_end

            FROM $tablename

            WHERE desk_id IN ($offices_id) $cleaner_sql_part AND room = $room AND booking_type = 'cleaning' GROUP BY date_end

            ORDER BY date_end DESC limit 5";



    $data = $wpdb->get_results($sql,'ARRAY_A');

    if(!$wpdb->num_rows) return null;

    if(empty($data)) return null;

    return $data;

}



function adapte_the_date_format($date,$format='Y-m-d H:i:s'){

    if( !check_date_input($date) ) return ;

    $new_format = str_replace('/','-',sanitize_text_field($date ?? ''));

    $date_timestamp = strtotime($new_format);
    $current_timestamp = time();
    if ($date_timestamp < $current_timestamp) {
        return ;
    }

    $new_format = date($format, $date_timestamp);

    return $new_format;

}

function check_date_input($date){

    $date = date('d/m/Y H:i', strtotime($date));

    $origin_date = $date;

    $date_time = seperate_date_time($date);

    if(empty($date_time)) return false;

    $date = explode('/',$date_time[0]);

    $mounth = !empty($date[1]) ? (int)$date[1] : 0;

    $day =  !empty($date[0]) ? (int)$date[0] : 0 ;

    $year =  !empty($date[2]) ? (int)$date[2] : 0;

    if(!empty($date_time[1])){

        $time = $date_time[1];

        $check_time = preg_match("/^(?:2[0-3]|[01][0-9]):[0-5][0-9]$/", $time);

        return ($check_time && wp_checkdate($mounth,$day,$year,$origin_date)) ;

    }

    return wp_checkdate($mounth,$day,$year,$origin_date);

}

function seperate_date_time($date_time){

    if(empty($date_time)) return;

    return explode(' ',$date_time);

}

function get_building_in_specifique_city($city,$taxonomy='buildings'){

    if(!is_numeric($city) ) return;

    $terms = get_terms( $taxonomy,

    array(

        'hide_empty' => 0,

        'parent' => 0,

        'meta_query' => array(

            array(

               'key'       => 'city_of_building',

               'value'     => $city,

               'compare'   => '='

            )

       )

    ));

    if(is_wp_error($terms)) return;

    

    return $terms;

}

function booking_set_error($key,$error=''){

    try {

        setcookie($key,$error);

    } catch (Exception $e) {

        echo 'Message: ' .$e->getMessage();die;

    }   

}

function booking_show_error($key){

    $error ='';

    if(empty($_COOKIE[$key]))

        return false;

    $error = $_COOKIE[$key];

    setcookie($key,null); 

    return $error;

}

function get_floor_from_string($string){

    $floor = '';

      $checking_floor = strpos($string,'ground');

      if( $checking_floor || $checking_floor === 0 )

        $floor = 'ground';

      elseif(is_numeric($string[0]))

        $floor = $string[0];   

      else{

          $floor_key = str_replace(' floor','',$string);

          $_index = array_search(ucfirst($floor_key),return_ordinal_number());

          if($_index !== false){

              $floor = $_index + 1;

            }

      }

    return $floor;

}

function set_room_cleaning_schedule($args = array()){

    

    if( empty($args) || empty($args['location']) || empty($args['building']) || empty($args['room']) 

                    || empty($args['floor']) || empty($args['date_start']) || empty($args['date_end'])  ) return 'all fields are required';

    

    $floor = return_ordinal_number($args['floor']).' Floor';

    $reserved_office = get_reserved_offices($args['date_start'],$args['date_end'],true,array('floor'=>$floor),false);

    $items = get_posts(array( 

                        'post_type'=>'desks',

                        'posts_per_page'=>-1,

                        'tax_query' => array(

                            'relation' => 'AND',

                            array(

                                'taxonomy' => 'location',

                                'field'    => 'term_id',

                                'terms'    => $args['location']

                            ),

                            array(

                                'taxonomy' => 'buildings',

                                'field'    => 'term_id',

                                'terms'    => $args['building']

                            )

                        ),

                        'meta_query' => array(

                            'relation' => 'AND',

                            array(

                                'key'   => '_room',

                                'value' => $args['room'],

                            ),

                            array(

                                'key'   => '_floor',

                                'value' => $args['floor'],

                            )

                        )

                    ));    

    if(array_intersect($reserved_office,array_column($items,'ID'))) return "you can't clean this room at this time :".$args['date_start']." to ".$args['date_end']." it's occuped";

    if(empty($items)) return "the selected  room is empty (no offices yet)";

    $room_is_reserved = true;

    foreach ( $items as  $item) {

        $id_product = $item->ID;

        $booking_info = array(

                        'cleaner_id' => $args['cleaner'],

                        'desk_id' => $id_product,

                        'room' => $args['room'],

                        'seat' => 0,

                        'floor' => strtolower($floor),

                        'date_start' => $args['date_start'],

                        'date_end' => $args['date_end'],

                        'order_id' => 0,

                        'booking_type' => 'cleaning'

                    );

        $reservation_id = insert_into_db('booking_info',$booking_info);

        if (!$reservation_id){

            $room_is_reserved = false;

            break;

        }

    }

    return $room_is_reserved;

}



function generate_unique_pass_code() {

    global $wpdb;



    // Replace 'booking_info' with your actual table name if it's different.

    $table_name = $wpdb->prefix . 'booking_info';



    do {

        $pass_code = sprintf("%06d", mt_rand(0, 999999));

        $query = $wpdb->prepare("SELECT COUNT(*) FROM $table_name WHERE pass_code = %s", $pass_code);

        $count = $wpdb->get_var($query);

    } while ($count > 0);



    return $pass_code;

}



function set_reservation_function($first_name,$Last_name,$phone_number,$email,$city,$reservation_status,$items,$order_id,$reservation_type='booking'){

    

    $client_id = check_row_exist('client_info','email',$email);

    if(!$client_id){

        $first_name = sanitize_text_field($first_name ?? '');

        $Last_name = sanitize_text_field($Last_name ?? '');

        $phone_number = sanitize_text_field($phone_number ?? '');

        $email = sanitize_text_field($email ?? '');

        $city = sanitize_text_field($city ?? '');

        $user_id = get_current_user_id();

        $client_info = array(

                            'first_name' => $first_name,

                            'last_name' => $Last_name,

                            'phone_number' => $phone_number,

                            'email' => $email,

                            'city' => $city,

                            'user_ID' => $user_id

                        );

        $client_id = insert_into_db('client_info',$client_info);

    }

    else

    $client_id = $client_id[0]->client_id;

    $order_status = $reservation_status;



    foreach ( $items as $item) {

        $id_product = sanitize_text_field($item['_ctpost_id'] ?? '');

        $Date_start = $item['_datestart'];

        $Date_end = $item['_dateend'];

        $desk_type = sanitize_text_field($item['_desk_type'] ?? '');

        $floor = strtolower(sanitize_text_field($item['_floor'] ?? ''));

        $room = sanitize_text_field($item['_room'] ?? '');

        $seat = sanitize_text_field($item['_seat'] ?? '');

        $pass_code = generate_unique_pass_code();

        $booking_info = array(

                        'client_id' => $client_id,

                        'desk_id' => $id_product,

                        'room' => $room,

                        'seat' => $seat,

                        'floor' => $floor,

                        'desk_type' => $desk_type,

                        'date_start' => $Date_start,

                        'date_end' => $Date_end,

                        'is_paid' => 'processing',//$order_status,

                        'order_id' => $order_id,

                        'booking_type' => $reservation_type,

                        'pass_code' => $pass_code

                    );

        $reservation_id = insert_into_db('booking_info',$booking_info);

        if (!$reservation_id)

            break;



    }

}



function return_ordinal_number($floor_i=null){

    $ordinal_numbers = ['First','Second','Third','Fourth','Fifth','Sixth','Seventh','Eighth','Ninth','Tenth'];

    if(is_numeric($floor_i))

        return $ordinal_numbers[$floor_i-1];

    elseif($floor_i == 'ground') 

        return 'Ground';

    return $ordinal_numbers;

}

function check_the_time_to_clean($date_time){

    $diff = true;

    // echo '<pre>';

    // var_dump($date_time);

    // echo '</pre>';

    // die;

    if(!empty($date_time)){

        foreach ($date_time as $dt) {

            if (DateTime::createFromFormat('Y-m-d H:i:s', $dt['date_end']) !== false) {

                $time_betwen_clean = 4;

                $given_date = new DateTime($dt['date_end']);

                $timezone = new DateTimeZone('Europe/Dublin');

                $now = new DateTime('now', $timezone);

                $diff = ($given_date->diff($now)->h >= $time_betwen_clean);

                if(!$diff) break;

            }

        }

    }

    return $diff;

}



function get_cleaners($return_html=false){

    $cleaners = get_users(array('role' => 'cleaner', 'fields' => array('ID', 'display_name')));

    if(!$return_html)

        return $cleaners;

    

    $cleaners_html = '<select class="cleaners-select" name="cleaners-select">';

    $cleaners_html_option = '<option>No cleaner yet</option>';

    if(!empty($cleaners)){

        $cleaners_html_option = '<option value="0"> Select a cleaner </option>';

        foreach ($cleaners as $cleaner)

            $cleaners_html_option .= '<option value="' . $cleaner->id . '">' . $cleaner->display_name . '</option>';

    }

    $cleaners_html .= $cleaners_html_option. '</select>';

    return  array('html'=>$cleaners_html,'data'=>$cleaners);



}