<?php
/**
 * Cart Page
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/cart/cart.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce\Templates
 * @version 3.8.0
 */

defined( 'ABSPATH' ) || exit;

// do_action( 'woocommerce_before_cart' ); ?>

<form class="woocommerce-cart-form col-sm-8" action="<?php echo esc_url( wc_get_cart_url() ); ?>" method="post">
	<?php do_action( 'woocommerce_before_cart_table' ); ?>
	<div class="table-section-heading">
		<h1>Upcoming Booking Details</h1>
	</div>
	<div class="table-container">
		
		<?php do_action( 'woocommerce_before_cart' ); ?> 
		<table class="shop_table shop_table_responsive cart woocommerce-cart-form__contents" cellspacing="0">
			<thead>
				<tr>
					<!-- <th class="product-remove">&nbsp;</th>
					<th class="product-thumbnail">&nbsp;</th>
					<th class="product-name"><?php esc_html_e( 'Booking', 'woocommerce' ); ?></th>
					<th class="product-details"><?php esc_html_e( 'Product Details', 'woocommerce' ); ?></th>
					<th class="product-price"><?php esc_html_e( 'Price', 'woocommerce' ); ?></th>
					<th class="product-days"><?php esc_html_e( 'Duration', 'woocommerce' ); ?></th>
					<th class="product-date"><?php esc_html_e( 'Dates', 'woocommerce' ); ?></th>
					<th class="product-subtotal"><?php esc_html_e( 'Subtotal', 'woocommerce' ); ?></th> -->
				</tr>
			</thead>
			<tbody class="table-rows">
				<?php do_action( 'woocommerce_before_cart_contents' ); ?>

				<?php
				
				foreach ( WC()->cart->get_cart() as $cart_item_key => $cart_item ) {
					$_product   = apply_filters( 'woocommerce_cart_item_product', $cart_item['data'], $cart_item, $cart_item_key );
					$product_id = apply_filters( 'woocommerce_cart_item_product_id', $cart_item['product_id'], $cart_item, $cart_item_key );
					$number_day = get_date_diff($cart_item["datestart"],$cart_item["dateend"]);
					if ( $_product && $_product->exists() && $cart_item['quantity'] > 0 && apply_filters( 'woocommerce_cart_item_visible', true, $cart_item, $cart_item_key ) ) {
						// $product_permalink = apply_filters( 'woocommerce_cart_item_permalink', $_product->is_visible() ? $_product->get_permalink( $cart_item ) : '', $cart_item, $cart_item_key );
						?>
						<tr class="woocommerce-cart-form__cart-item <?php echo esc_attr( apply_filters( 'woocommerce_cart_item_class', 'cart_item', $cart_item, $cart_item_key ) ); ?>">
						<div>
							<td class="product-remove">
								<?php
									echo apply_filters( // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
										'woocommerce_cart_item_remove_link',
										sprintf(
											'<a href="%s" class="remove" aria-label="%s" data-product_id="%s" data-product_sku="%s">&times;</a>',
											esc_url( wc_get_cart_remove_url( $cart_item_key ) ),
											esc_html__( 'Remove this item', 'woocommerce' ),
											esc_attr( $product_id ),
											esc_attr( $_product->get_sku() )
										),
										$cart_item_key
									);
								?>
							</td>
							<td class="table-first-cell">
								<div class="product-quantity" data-title="<?php esc_attr_e( 'Dates', 'woocommerce' ); ?>">
									<?php
									/*if ( $_product->is_sold_individually() ) {
										$product_quantity = sprintf( '1 <input type="hidden" name="cart[%s][qty]" value="1" />', $cart_item_key );
									} else {
										$product_quantity = woocommerce_quantity_input(
											array(
												'input_name'   => "cart[{$cart_item_key}][qty]",
												'input_value'  => $cart_item['quantity'],
												'max_value'    => $_product->get_max_purchase_quantity(),
												'min_value'    => '0',
												'product_name' => $_product->get_name(),
											),
											$_product,
											false
										);
									}

									echo apply_filters( 'woocommerce_cart_item_quantity', $product_quantity, $cart_item_key, $cart_item ); // PHPCS: XSS ok.*/
									?>
									

								</div>
								
								<!-- <?php
								$number_days =  $number_day;
								$_lebele = ' Day(s)';
								if($number_day < 1){
									$number_days =  round($number_day*12);
									$_lebele = ' Hours(s)';
									
								}
								?> -->
								<div class="product-days" data-title="<?php esc_attr_e( $_lebele, 'woocommerce' ); ?>">
									<?php
									
									$dateStart = new DateTime($cart_item["datestart"]);
									$dateEnd = new DateTime($cart_item["dateend"]);

									
									$interval = $dateStart->diff($dateEnd);

									 // Debugging output
										// echo "<pre>";
										// echo "Start Date: " . $dateStart->format('Y-m-d H:i:s') . "<br>";
										// echo "End Date: " . $dateEnd->format('Y-m-d H:i:s') . "<br>";
										// echo "Interval: " . print_r($interval, true) . "<br>";
										// echo "</pre>";
									if ($interval->days == 0 && $interval->h == 12 && $interval->i == 0 && $interval->s == 0) {
										$number_days = 1;
										$_lebele = ' Day';
									} elseif ($interval->days == 0 && $interval->h > 0) {
										$number_days = $interval->h;
										$_lebele = $number_days > 1 ? ' Hours' : ' Hour'; 
									} else {
										$number_days = $interval->days + 1; 
										$_lebele = $number_days > 1 ? ' Days' : ' Day';
									}

									
									$monthName = $dateStart->format('F'); 
									$startDay = $dateStart->format('d');
									$endDay = $dateEnd->format('d');
									$dayRange = $startDay . ($startDay === $endDay ? "" : "-{$endDay}"); 

									?>
									
									<p class='month-name'><?php echo $monthName; ?></p>

									<p class='day-range'><?php echo $dayRange; ?></p>

									<svg id="calendar_7_" data-name="calendar (7)" xmlns="http://www.w3.org/2000/svg" width="22.997" height="22.987" viewBox="0 0 22.997 22.987">
										<path id="Path_116993" data-name="Path 116993" d="M18.557,1.88H17.7V1.012a.9.9,0,0,0-1.8,0V1.88H7.094V1.012a.9.9,0,0,0-1.8,0V1.88H4.44A4.445,4.445,0,0,0,0,6.32V18.661A4.445,4.445,0,0,0,4.44,23.1H18.557A4.445,4.445,0,0,0,23,18.661V6.32a4.445,4.445,0,0,0-4.44-4.44ZM4.44,3.676H5.3V5.427a.9.9,0,0,0,1.8,0V3.676H15.9V5.427a.9.9,0,0,0,1.8,0V3.676h.858A2.647,2.647,0,0,1,21.2,6.32v.858H1.8V6.32A2.647,2.647,0,0,1,4.44,3.676ZM18.557,21.305H4.44A2.647,2.647,0,0,1,1.8,18.661V8.974H21.2v9.687A2.647,2.647,0,0,1,18.557,21.305Zm-10.581-8.8a.9.9,0,0,1-.9.9H5.313a.9.9,0,1,1,0-1.8H7.079A.9.9,0,0,1,7.977,12.505Zm10.606,0a.9.9,0,0,1-.9.9H15.919a.9.9,0,1,1,0-1.8h1.766A.9.9,0,0,1,18.583,12.505Zm-5.308,0a.9.9,0,0,1-.9.9H10.611a.9.9,0,1,1,0-1.8h1.766A.9.9,0,0,1,13.274,12.505Zm-5.3,5.3a.9.9,0,0,1-.9.9H5.313a.9.9,0,1,1,0-1.8H7.079A.9.9,0,0,1,7.977,17.8Zm10.606,0a.9.9,0,0,1-.9.9H15.919a.9.9,0,1,1,0-1.8h1.766A.9.9,0,0,1,18.583,17.8Zm-5.308,0a.9.9,0,0,1-.9.9H10.611a.9.9,0,1,1,0-1.8h1.766A.9.9,0,0,1,13.274,17.8Z" transform="translate(0 -0.114)" fill="#1c232e"/>
									</svg>

									<p class='days-number'><?php echo $number_days . $_lebele; ?></p>

								</div>
							</td>
							
							<td id="vertical-divider"></td>
							
							<td class="second-cell">
							
							<div class="second-cell-div">
								<div class="product-name" data-title="<?php esc_attr_e( 'Booking', 'woocommerce' ); ?>">
									<div class="cart-table-cell">
										<svg xmlns="http://www.w3.org/2000/svg" width="11.5" height="15.333" viewBox="0 0 11.5 15.333" >
											<path class="location-pin" id="location-pin" d="M8.75,0A5.777,5.777,0,0,0,3,5.792c0,4.538,5.209,9.224,5.431,9.42a.48.48,0,0,0,.638,0c.222-.2,5.431-4.883,5.431-9.421A5.777,5.777,0,0,0,8.75,0Zm0,8.944A3.194,3.194,0,1,1,11.944,5.75,3.2,3.2,0,0,1,8.75,8.944Z" transform="translate(-3)" fill="#fff"/>
										</svg>
										<div>
											<p>Location:</p>
											<?php
												$location_id = $cart_item['city'];
												$location_term = get_term_by( 'id', $location_id, 'location' );
												$location_name = $location_term ? $location_term->name : "";

												
													
													// echo '<p>'.$location_name.'</p>';
												?>

												<span><?php echo $location_name; ?></span>
											<!-- <?php
											
											echo wp_kses_post( apply_filters( 'woocommerce_cart_item_name', sprintf( '<span href="">'.$_product->get_name().'</span>' ), $cart_item, $cart_item_key ) );

											do_action( 'woocommerce_after_cart_item_name', $cart_item, $cart_item_key );

											// Meta data.
											echo wc_get_formatted_cart_item_data( $cart_item ); // PHPCS: XSS ok.

											// Backorder notification.
											if ( $_product->backorders_require_notification() && $_product->is_on_backorder( $cart_item['quantity'] ) ) {
												echo wp_kses_post( apply_filters( 'woocommerce_cart_item_backorder_notification', '<p class="backorder_notification">' . esc_html__( 'Available on backorder', 'woocommerce' ) . '</p>', $product_id ) );
											}
											?> -->
										</div>
									</div>
								</div>
								<div class="product-price" data-title="<?php esc_attr_e( 'Price/day', 'woocommerce' ); ?>">
									<div class="cart-table-cell">
										<svg id="Group_167193" data-name="Group 167193" xmlns="http://www.w3.org/2000/svg" width="11.5" height="14.153" viewBox="0 0 11.5 14.153">
											<g id="Group_167192" data-name="Group 167192">
												<path id="Path_124094" data-name="Path 124094" d="M138.116,139.707a3.763,3.763,0,0,1-2.155.678,4.347,4.347,0,0,1-3.807-2.654h2.923a.885.885,0,0,0,0-1.769h-3.464a5.3,5.3,0,0,1,0-1.769h4.349a.885.885,0,1,0,0-1.769h-3.807a4.347,4.347,0,0,1,3.807-2.654,3.763,3.763,0,0,1,2.155.678.885.885,0,0,0,1-1.461,5.582,5.582,0,0,0-3.153-.985,6.265,6.265,0,0,0-5.732,4.423h-1.345a.885.885,0,0,0,0,1.769h.962a5.065,5.065,0,0,0,0,1.769h-.962a.885.885,0,0,0,0,1.769h1.345a6.265,6.265,0,0,0,5.732,4.423,5.582,5.582,0,0,0,3.153-.985.885.885,0,0,0-1-1.461Z" transform="translate(-128 -128)" fill="#fff"/>
											</g>
										</svg>
										<div>
											<p>Rate:</p>
											<span>
											<?php
												$desk_type =  get_term_by('name',$cart_item['desk_type'],'workspace-type');
												$slug_type = $desk_type ? $desk_type->slug : '';
												echo  get_woocommerce_currency_symbol() .' '. apply_filters( 'woocommerce_cart_item_price',calcul_price_per_days( $number_days,$product_id,  $slug_type ,''), $cart_item, $cart_item_key ); // PHPCS: XSS ok.
											?>
											  plus VAT
											</span>
										</div>
									</div>
								</div>
							</div>
							<div class="second-cell-div">
								<div class="product-details" data-title="<?php esc_attr_e( 'Product Details', 'woocommerce' ); ?>" >
									<div class="cart-table-cell">
										<svg xmlns="http://www.w3.org/2000/svg" width="11.5" height="15.215" viewBox="0 0 11.5 15.215">
											<g id="office-chair_4_" data-name="office-chair (4)" transform="translate(0 0)">
												<g id="Group_167614" data-name="Group 167614" transform="translate(2.557 0)">
												<g id="Group_167613" data-name="Group 167613" transform="translate(0)">
													<path id="Path_124164" data-name="Path 124164" d="M147.656,2.388A2.456,2.456,0,0,0,145.2,0h-1.183a2.456,2.456,0,0,0-2.455,2.388l-.146,5.228H147.8Z" transform="translate(-141.416 0)" fill="#fff"/>
												</g>
												</g>
												<g id="Group_167616" data-name="Group 167616" transform="translate(0 7.28)">
												<g id="Group_167615" data-name="Group 167615">
													<path id="Path_124165" data-name="Path 124165" d="M60.6,227.241H59.3a.556.556,0,0,0-.375.966v.8h-7.03v-.8a.556.556,0,0,0-.375-.966h-1.3a.556.556,0,0,0,0,1.113h.565v.947a1.956,1.956,0,0,0,1.954,1.954h2.118v2.27H53.786a.556.556,0,0,0-.556.556v.539a.556.556,0,0,0,1.113.018h.51a.556.556,0,0,0,1.111,0h.51a.556.556,0,0,0,1.113-.018v-.539a.556.556,0,0,0-.556-.556H55.964v-2.27h2.118a1.956,1.956,0,0,0,1.954-1.954v-.947H60.6a.556.556,0,1,0,0-1.113Z" transform="translate(-49.658 -227.241)" fill="#fff"/>
												</g>
												</g>
											</g>
										</svg>
											<div>
												<?php
												$office_name ='';

													$office_name .= !empty($cart_item['desk_type']) ? ' <p class="desk-type styled-bold"><span class ="styled-bold"></span> '.$cart_item['desk_type'].':</p> ' : '';
													$office_name .= !empty($cart_item['seat']) ? ' <span class="desk-seat"> Seat '.$cart_item['seat'].',</span> ' : '';
													$office_name .= !empty($cart_item['room']) ? ' <span class="desk-room">Room '.$cart_item['room'].',</span> ' : '';
													$office_name .= !empty($cart_item['floor']) ? ' <span class="desk-floor"><span class ="styled-bold"></span>'.$cart_item['floor'].'</span> ' : '';
													echo '<p>'.$office_name.'</p>';
												?>

												<?php
												
													// echo wp_kses_post( apply_filters( 'woocommerce_cart_item_name', sprintf( '<span href="">'.$_product->get_name().'</span>' ), $cart_item, $cart_item_key ) );

													do_action( 'woocommerce_after_cart_item_name', $cart_item, $cart_item_key );

													// Meta data.
													echo wc_get_formatted_cart_item_data( $cart_item ); // PHPCS: XSS ok.

													// Backorder notification.
													if ( $_product->backorders_require_notification() && $_product->is_on_backorder( $cart_item['quantity'] ) ) {
														echo wp_kses_post( apply_filters( 'woocommerce_cart_item_backorder_notification', '<p class="backorder_notification">' . esc_html__( 'Available on backorder', 'woocommerce' ) . '</p>', $product_id ) );
													}
												?>
											</div>
									</div>
								</div>

								<div class="product-subtotal" data-title="<?php esc_attr_e( 'Subtotal', 'woocommerce' ); ?>">
									<div class="cart-table-cell">
										<svg xmlns="http://www.w3.org/2000/svg" width="11.5" height="11.5" viewBox="0 0 11.5 11.5">
											<path id="calendar_9_" data-name="calendar (9)" d="M22.2,22.188h1.716v-.944A.245.245,0,0,1,24.158,21h.552a.245.245,0,0,1,.245.245v.944h3.591v-.944A.245.245,0,0,1,28.79,21h.552a.245.245,0,0,1,.245.245v.944H31.3a1.2,1.2,0,0,1,1.2,1.2v.768H21v-.768a1.2,1.2,0,0,1,1.2-1.2Zm10.3,2.553V31.3a1.2,1.2,0,0,1-1.2,1.2H22.2A1.2,1.2,0,0,1,21,31.3V24.741Zm-9.585,1.432v1.486H24.4V26.173Zm0,3.116v1.486H24.4V29.289Zm6.183,0v1.486h1.486V29.289Zm-3.092,0v1.486h1.486V29.289ZM29.1,26.173v1.486h1.486V26.173Zm-3.092,0v1.486h1.486V26.173Z" transform="translate(-21 -21)" fill="#fff" fill-rule="evenodd"/>
										</svg>
										<div>
											<p>Dates:</p>

											<?php
												$date_start = date('d-m-Y', strtotime($cart_item["datestart"]));
												$date_end = date('d-m-Y', strtotime($cart_item["dateend"]));

												if ($date_start === $date_end) {
													echo '<span>' . $date_start . '</span>';
												} else {
													echo '<span>' . $date_start . '</span>';
													echo '<span>' . $date_end . '</span>';
												}
											?>

											
											<!-- <?php
												echo apply_filters( 'woocommerce_cart_item_subtotal', WC()->cart->get_product_subtotal( $_product, $cart_item['quantity'] ), $cart_item, $cart_item_key ); // PHPCS: XSS ok.
											?> -->
										</div>
									</div>
								</div>
							</div>
							</td>

							<td class="product-thumbnail">
								<?php
								$thumbnail = apply_filters( 'woocommerce_cart_item_thumbnail', $_product->get_image(), $cart_item, $cart_item_key );

								// if ( ! $product_permalink ) {
									echo $thumbnail; // PHPCS: XSS ok.
								// } else {
								// 	printf( '<a href="%s">%s</a>', esc_url( $product_permalink ), $thumbnail ); // PHPCS: XSS ok.
								// }
								?>
							</td>
						</tr>

						
						<?php
					}
				}
				?>

				<?php do_action( 'woocommerce_cart_contents' ); ?>

				<!-- <tr>
					<td colspan="6" class="actions">

						<?php if ( wc_coupons_enabled() ) { ?>
							<div class="coupon">
								<label for="coupon_code"><?php esc_html_e( 'Coupon:', 'woocommerce' ); ?></label> <input type="text" name="coupon_code" class="input-text" id="coupon_code" value="" placeholder="<?php esc_attr_e( 'Coupon code', 'woocommerce' ); ?>" /> <button type="submit" class="button" name="apply_coupon" value="<?php esc_attr_e( 'Apply coupon', 'woocommerce' ); ?>"><?php esc_attr_e( 'Apply coupon', 'woocommerce' ); ?></button>
								<?php do_action( 'woocommerce_cart_coupon' ); ?>
							</div>
						<?php } ?>

						<?php do_action( 'woocommerce_cart_actions' ); ?>

						<?php wp_nonce_field( 'woocommerce-cart', 'woocommerce-cart-nonce' ); ?>
					</td>
				</tr> -->

				<?php do_action( 'woocommerce_after_cart_contents' ); ?>
			</tbody>
		</table>
	</div>
	<?php do_action( 'woocommerce_after_cart_table' ); ?>
</form>

<?php do_action( 'woocommerce_before_cart_collaterals' ); ?>

<div class="cart-collaterals col-sm-4">
	<div class="checkout-section-heading ">
		<h1>Order Summary</h1>
	</div>
	<?php
		/**
		 * Cart collaterals hook.
		 *
		 * @hooked woocommerce_cross_sell_display
		 * @hooked woocommerce_cart_totals - 10
		 */
		do_action( 'woocommerce_cart_collaterals' );
	?>

	
</div>

<?php do_action( 'woocommerce_after_cart' ); ?>
