<?php
/**
 * Review order table
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/checkout/review-order.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see https://woo.com/document/template-structure/
 * @package WooCommerce\Templates
 * @version 5.2.0
 */

defined( 'ABSPATH' ) || exit;
?>
<table class="shop_table woocommerce-checkout-review-order-table">
	<thead>
		<!-- <tr>
			<th class="product-name"><?php esc_html_e( 'Product', 'woocommerce' ); ?></th>
			<th class="product-total"><?php esc_html_e( 'Subtotal', 'woocommerce' ); ?></th>
		</tr> -->
	</thead>
	<tbody class="order-item-column">
		<?php
		do_action( 'woocommerce_review_order_before_cart_contents' );

		foreach ( WC()->cart->get_cart() as $cart_item_key => $cart_item ) {
			$_product = apply_filters( 'woocommerce_cart_item_product', $cart_item['data'], $cart_item, $cart_item_key );
			$desk_type = ! empty( $cart_item['desk_type'] ) ? $cart_item['desk_type'] . ': ' : '';
			$seat = ! empty( $cart_item['seat'] ) ? 'Seat ' . $cart_item['seat'] . ' ' : '';
			$room = ! empty( $cart_item['room'] ) ? 'Room ' . $cart_item['room'] : '';
			$date = ! empty( $cart_item['date'] ) ? 'Date: ' . $cart_item['date'] . ', ' : '';
			$floor = ! empty( $cart_item['floor'] ) ? ' ' . $cart_item['floor'] . ' ' : '';
			$number_day = get_date_diff($cart_item["datestart"],$cart_item["dateend"]);
			$number_of_days = ! empty( $cart_item['number_of_days'] ) ? $cart_item['number_of_days'] : '';
			$full_location =  $room . ', ' . $floor;

			if ( $_product && $_product->exists() && $cart_item['quantity'] > 0 && apply_filters( 'woocommerce_checkout_cart_item_visible', true, $cart_item, $cart_item_key ) ) {
				?>
				<tr class=" <?php echo esc_attr( apply_filters( 'woocommerce_cart_item_class', 'cart-subtotal', $cart_item, $cart_item_key ) ); ?>">
					<!-- <td class="product-name">
						<?php echo wp_kses_post( apply_filters( 'woocommerce_cart_item_name', $_product->get_name(), $cart_item, $cart_item_key ) ) . '&nbsp;'; ?>
						<?php echo apply_filters( 'woocommerce_checkout_cart_item_quantity', ' <strong class="product-quantity">' . sprintf( '&times;&nbsp;%s', $cart_item['quantity'] ) . '</strong>', $cart_item, $cart_item_key ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>
						<?php echo wc_get_formatted_cart_item_data( $cart_item ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>
					</td>
					
					<td class="product-total">
						<?php echo apply_filters( 'woocommerce_cart_item_subtotal', WC()->cart->get_product_subtotal( $_product, $cart_item['quantity'] ), $cart_item, $cart_item_key ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>
					</td> -->

					<td data-title=" <?php echo esc_html( $desk_type . ' - ' . $number_of_days . ' days' ); ?>">
				
					<div data-title="<?php esc_attr_e( $_lebele, 'woocommerce' ); ?>">
						<?php
										
						$dateStart = new DateTime($cart_item["datestart"]);
						$dateEnd = new DateTime($cart_item["dateend"]);

										
						$interval = $dateStart->diff($dateEnd);

						if ($interval->days == 0 && $interval->h == 12 && $interval->i == 0 && $interval->s == 0) {
							$number_days = 1;
							$_lebele = ' Day';
						} elseif ($interval->days == 0 && $interval->h > 0) {
										
							// $number_days = $interval->h;

							$display_hours = $interval->h;
							$_lebele = $display_hours > 1 ? ' Hours' : ' Hour'; 
							$number_days = 1; 
							$_lebele = $number_days >= 1 ? ' Hours' : ' Hour'; 
						} else {
											
							$number_days = $interval->days + 1; 
							$_lebele = $number_days > 1 ? ' Days' : ' Day';
						}

										
						$monthName = $dateStart->format('F'); 
						$startDay = $dateStart->format('d');
						$endDay = $dateEnd->format('d');
						$dayRange = $startDay . ($startDay === $endDay ? "" : "-{$endDay}"); 

						?>
										
					</div>
					<?php 
						// Display correct label for hours or days
						if (isset($display_hours)) {
							echo esc_html($desk_type . ' ' . $display_hours . $_lebele); 
						} else {
							echo esc_html($desk_type . ' ' . $number_days . $_lebele); 
						}
					?>

			
			
				</td>
				<td>

					<?php
						$desk_type =  get_term_by('name',$cart_item['desk_type'],'workspace-type');
						$slug_type = $desk_type ? $desk_type->slug : '';
						// echo  get_woocommerce_currency_symbol() .' '. apply_filters( 'woocommerce_cart_item_price', calcul_price_per_days($product_id,'',$number_day,$slug_type), $cart_item, $cart_item_key ); // PHPCS: XSS ok.
						
						$price_per_day = calcul_price_per_days( $number_days,$product_id,  $slug_type ,'');
						$total_unit_price =  $price_per_day;

						echo get_woocommerce_currency_symbol() . ' ' . apply_filters('woocommerce_cart_item_price', $total_unit_price, $cart_item, $cart_item_key); // PHPCS: XSS ok.
					?>

					<!-- <?php
						$desk_type =  get_term_by('name',$cart_item['desk_type'],'workspace-type');
						$slug_type = $desk_type ? $desk_type->slug : '';
						echo  get_woocommerce_currency_symbol() .' '. apply_filters( 'woocommerce_cart_item_price', calcul_price_per_days( $number_days,$product_id,  $slug_type ,''), $cart_item, $cart_item_key ); // PHPCS: XSS ok.
					?> -->

					<!-- <?php wc_cart_totals_subtotal_html(); ?> -->
				</td>
				</tr>
				<tr class="order-room">
				<th class="order-item-info">
				<svg xmlns="http://www.w3.org/2000/svg" width="11.5" height="15.215" viewBox="0 0 11.5 15.215">
					<g id="office-chair_4_" data-name="office-chair (4)" transform="translate(0 0)">
						<g id="Group_167614" data-name="Group 167614" transform="translate(2.557 0)">
						<g id="Group_167613" data-name="Group 167613" transform="translate(0)">
							<path id="Path_124164" data-name="Path 124164" d="M147.656,2.388A2.456,2.456,0,0,0,145.2,0h-1.183a2.456,2.456,0,0,0-2.455,2.388l-.146,5.228H147.8Z" transform="translate(-141.416 0)" fill="#2bd28d"/>
						</g>
						</g>
						<g id="Group_167616" data-name="Group 167616" transform="translate(0 7.28)">
						<g id="Group_167615" data-name="Group 167615">
							<path id="Path_124165" data-name="Path 124165" d="M60.6,227.241H59.3a.556.556,0,0,0-.375.966v.8h-7.03v-.8a.556.556,0,0,0-.375-.966h-1.3a.556.556,0,0,0,0,1.113h.565v.947a1.956,1.956,0,0,0,1.954,1.954h2.118v2.27H53.786a.556.556,0,0,0-.556.556v.539a.556.556,0,0,0,1.113.018h.51a.556.556,0,0,0,1.111,0h.51a.556.556,0,0,0,1.113-.018v-.539a.556.556,0,0,0-.556-.556H55.964v-2.27h2.118a1.956,1.956,0,0,0,1.954-1.954v-.947H60.6a.556.556,0,1,0,0-1.113Z" transform="translate(-49.658 -227.241)" fill="#2bd28d"/>
						</g>
						</g>
					</g>
				</svg>

					<p><?php echo esc_html( $seat ); ?></p>
				</th>
			</tr>
			<tr class="order-location">
				<th class="order-item-info">
				<svg xmlns="http://www.w3.org/2000/svg" width="11.5" height="15.333" viewBox="0 0 11.5 15.333">
					<path id="location-pin" d="M8.75,0A5.777,5.777,0,0,0,3,5.792c0,4.538,5.209,9.224,5.431,9.42a.48.48,0,0,0,.638,0c.222-.2,5.431-4.883,5.431-9.421A5.777,5.777,0,0,0,8.75,0Zm0,8.944A3.194,3.194,0,1,1,11.944,5.75,3.2,3.2,0,0,1,8.75,8.944Z" transform="translate(-3)" fill="#2bd28d"/>
				</svg>

					<p><?php echo esc_html( $full_location); ?></p>
				</th>
			</tr>
			<tr class="order-date">
				<th class="order-item-info">
					<svg xmlns="http://www.w3.org/2000/svg" width="11.5" height="11.5" viewBox="0 0 11.5 11.5">
						<path id="calendar_9_" data-name="calendar (9)" d="M22.2,22.188h1.716v-.944A.245.245,0,0,1,24.158,21h.552a.245.245,0,0,1,.245.245v.944h3.591v-.944A.245.245,0,0,1,28.79,21h.552a.245.245,0,0,1,.245.245v.944H31.3a1.2,1.2,0,0,1,1.2,1.2v.768H21v-.768a1.2,1.2,0,0,1,1.2-1.2Zm10.3,2.553V31.3a1.2,1.2,0,0,1-1.2,1.2H22.2A1.2,1.2,0,0,1,21,31.3V24.741Zm-9.585,1.432v1.486H24.4V26.173Zm0,3.116v1.486H24.4V29.289Zm6.183,0v1.486h1.486V29.289Zm-3.092,0v1.486h1.486V29.289ZM29.1,26.173v1.486h1.486V26.173Zm-3.092,0v1.486h1.486V26.173Z" transform="translate(-21 -21)" fill="#2bd28d" fill-rule="evenodd"/>
					</svg>
					<?php
						$date_start = date('d-m-Y', strtotime($cart_item["datestart"]));
						$date_end = date('d-m-Y', strtotime($cart_item["dateend"]));

						if ($date_start === $date_end) {
							echo '<span>' . $date_start . '</span>';
						} else {
							echo '<span>' . $date_start . '</span>';
							echo '<span>' . $date_end . '</span>';
						}
					?>

					<p><?php echo " $formatted_date " ?></p>
					<!-- <span><?php echo date('Y-m-d', strtotime($cart_item["datestart"])); ?></span>
											<span><?php echo date('Y-m-d', strtotime($cart_item["datestart"]));?></span>
					<p><?php echo esc_html( $date ); ?></p> -->
				</th>
			</tr>
				
				<?php
			}
		}

		do_action( 'woocommerce_review_order_after_cart_contents' );
		?>	
			
			
		
	</tbody>
	<tfoot>

		<?php foreach ( WC()->cart->get_coupons() as $code => $coupon ) : ?>
			<tr class="cart-discount coupon-<?php echo esc_attr( sanitize_title( $code ) ); ?>">
				<td><?php wc_cart_totals_coupon_label( $coupon ); ?></td>
				<td><?php wc_cart_totals_coupon_html( $coupon ); ?></td>
			</tr>
		<?php endforeach; ?>

		<?php if ( WC()->cart->needs_shipping() && WC()->cart->show_shipping() ) : ?>

			<?php do_action( 'woocommerce_review_order_before_shipping' ); ?>

			<?php wc_cart_totals_shipping_html(); ?>

			<?php do_action( 'woocommerce_review_order_after_shipping' ); ?>

		<?php endif; ?>

		<?php foreach ( WC()->cart->get_fees() as $fee ) : ?>
			<tr class="fee">
				<td><?php echo esc_html( $fee->name ); ?></td>
				<td><?php wc_cart_totals_fee_html( $fee ); ?></td>
			</tr>
		<?php endforeach; ?>

		<?php if ( wc_tax_enabled() && ! WC()->cart->display_prices_including_tax() ) : ?>
			<?php if ( 'itemized' === get_option( 'woocommerce_tax_total_display' ) ) : ?>
				<?php foreach ( WC()->cart->get_tax_totals() as $code => $tax ) : // phpcs:ignore WordPress.WP.GlobalVariablesOverride.Prohibited ?>
					<tr class="tax-rate tax-rate-<?php echo esc_attr( sanitize_title( $code ) ); ?>">
						<td><?php echo esc_html( $tax->label ); ?></td>
						<td><?php echo wp_kses_post( $tax->formatted_amount ); ?></td>
					</tr>
				<?php endforeach; ?>
			<?php else : ?>
				<tr class="tax-total">
					<td><?php echo esc_html( WC()->countries->tax_or_vat() ); ?></td>
					<td><?php wc_cart_totals_taxes_total_html(); ?></td>
				</tr>
			<?php endif; ?>
		<?php endif; ?>

		<?php do_action( 'woocommerce_review_order_before_order_total' ); ?>
		<tr class="order-total">
			<td><?php esc_html_e( 'TOTAL', 'woocommerce' ); ?></td>
			<td><?php wc_cart_totals_order_total_html(); ?></td>
		</tr>
		<?php do_action( 'woocommerce_review_order_after_order_total' ); ?>

	</tfoot>
</table>
