<?php

/**

 * Thankyou page

 *

 * This template can be overridden by copying it to yourtheme/woocommerce/checkout/thankyou.php.

 *

 * HOWEVER, on occasion WooCommerce will need to update template files and you

 * (the theme developer) will need to copy the new files to your theme to

 * maintain compatibility. We try to do this as little as possible, but it does

 * happen. When this occurs the version of the template file will be bumped and

 * the readme will list any important changes.

 *

 * @see https://docs.woocommerce.com/document/template-structure/

 * @package WooCommerce\Templates

 * @version 3.7.0

 */



defined( 'ABSPATH' ) || exit;

?>



<div class="woocommerce-order">
		<div class="order-more-info col-sm-8 ">
			<h1>Booking confirmed successfully!</h1>

			<svg xmlns="http://www.w3.org/2000/svg" width="109" height="109" viewBox="0 0 109 109">
				<g id="Group_167721" data-name="Group 167721" transform="translate(-683 -402)">
					<circle id="Ellipse_2925" data-name="Ellipse 2925" cx="54.5" cy="54.5" r="54.5" transform="translate(683 402)" fill="#e8f9f1"/>
					<circle id="Ellipse_2926" data-name="Ellipse 2926" cx="43.5" cy="43.5" r="43.5" transform="translate(694 413)" fill="#d3f3e4"/>
					<circle id="Ellipse_2927" data-name="Ellipse 2927" cx="32.5" cy="32.5" r="32.5" transform="translate(705 424)" fill="#c2efda"/>
					<g id="correct" transform="translate(715.55 434.55)">
					<path id="Path_124242" data-name="Path 124242" d="M21.7,0A21.7,21.7,0,1,0,43.4,21.7,21.72,21.72,0,0,0,21.7,0Z" fill="#2bd28d" fill-rule="evenodd"/>
					<path id="Path_124243" data-name="Path 124243" d="M148.932,165.375a1.361,1.361,0,0,1,0,1.916l-12.715,12.715a1.351,1.351,0,0,1-1.916,0l-6.357-6.357a1.355,1.355,0,0,1,1.916-1.916l5.4,5.4,11.757-11.757A1.346,1.346,0,0,1,148.932,165.375Z" transform="translate(-116.738 -150.991)" fill="#fff" fill-rule="evenodd"/>
					</g>
				</g>
			</svg>

			<?php

			if ( $order ) :

				global $wpdb;
				$order_id = $order->get_id();
				$query = "SELECT pass_code FROM  {$wpdb->prefix}booking_info where  order_id = $order_id";
				$results =  $wpdb->get_results($query);
				
				if(!empty($results)){
					// Extracting passcodes using array_map
					$passcodes = array_map(function($item) {
						return $item->pass_code;
					}, $results);
				}
				
				$passcodes = implode(',',$passcodes);
			
				do_action( 'woocommerce_before_thankyou', $order->get_id() );

				?>



				<?php if ( $order->has_status( 'failed' ) ) : ?>



					<p class="woocommerce-notice woocommerce-notice--error woocommerce-thankyou-order-failed"><?php esc_html_e( 'Unfortunately your order cannot be processed as the originating bank/merchant has declined your transaction. Please attempt your purchase again.', 'woocommerce' ); ?></p>



					<p class="woocommerce-notice woocommerce-notice--error woocommerce-thankyou-order-failed-actions">

						<a href="<?php echo esc_url( $order->get_checkout_payment_url() ); ?>" class="button pay"><?php esc_html_e( 'Pay', 'woocommerce' ); ?></a>

						<?php if ( is_user_logged_in() ) : ?>

							<a href="<?php echo esc_url( wc_get_page_permalink( 'myaccount' ) ); ?>" class="button pay"><?php esc_html_e( 'My account', 'woocommerce' ); ?></a>

						<?php endif; ?>

					</p>



				<?php else : ?>
				


					<div class="woocommerce-notice woocommerce-notice--success woocommerce-thankyou-order-received"><?php echo apply_filters( 'woocommerce_thankyou_order_received_text', __( "<p class='thanks-paragraph'>Thank you for booking with Innova Rooms.<br/> Your booking is now confirmed. Please check your email to retrieve your building access code and booking information.</p> <p class='access-code'>Your access code is: $passcodes"), $order ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?></div>
					

					<ul class="woocommerce-order-overview woocommerce-thankyou-order-details order_details">



						<li class="woocommerce-order-overview__order order">

							<span><?php esc_html_e( 'Order number:', 'woocommerce' ); ?></span>

							<strong><?php echo $order->get_order_number(); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?></strong>

						</li>



						<li class="woocommerce-order-overview__date date">

							<span><?php esc_html_e( 'Date:', 'woocommerce' ); ?></span>

							<strong><?php echo wc_format_datetime( $order->get_date_created() ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?></strong>

						</li>



						<?php if ( is_user_logged_in() && $order->get_user_id() === get_current_user_id() && $order->get_billing_email() ) : ?>

							<li class="woocommerce-order-overview__email email">

								<span><?php esc_html_e( 'Email:', 'woocommerce' ); ?></span>

								<strong><?php echo $order->get_billing_email(); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?></strong>

							</li>

						<?php endif; ?>



						<li class="woocommerce-order-overview__total total">

							<span><?php esc_html_e( 'Total paid by ', 'woocommerce' ); ?> <?php echo wp_kses_post( $order->get_payment_method_title() ); ?></span>

							<strong><?php echo $order->get_formatted_order_total(); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?></strong>

						</li>



						<!-- <?php if ( $order->get_payment_method_title() ) : ?>

							<li class="woocommerce-order-overview__payment-method method">

								<?php esc_html_e( 'Payment method:', 'woocommerce' ); ?>

								<strong><?php echo wp_kses_post( $order->get_payment_method_title() ); ?></strong>

							</li>

						<?php endif; ?> -->



					</ul>



				<?php endif; ?>

				
			<!-- <span class="pay-way">
				<?php do_action( 'woocommerce_thankyou_' . $order->get_payment_method(), $order->get_id() ); ?>
			</span> -->

			<div class = "back_to_home">
				<!-- <svg id="arrow_5_" data-name="arrow (5)" xmlns="http://www.w3.org/2000/svg" width="13" height="11.267" viewBox="0 0 13 11.267">
					<g id="Group_157864" data-name="Group 157864">
						<path id="Path_116992" data-name="Path 116992" d="M12.218,36.553a.92.92,0,0,0-.161-.012H2.886l.2-.094a1.86,1.86,0,0,0,.526-.376l2.572-2.6a.98.98,0,0,0,.135-1.245.925.925,0,0,0-1.4-.122L.273,36.8a.947.947,0,0,0,0,1.329h0l4.651,4.7a.923.923,0,0,0,1.315,0,.94.94,0,0,0,.08-.092.98.98,0,0,0-.135-1.245l-2.567-2.6a1.861,1.861,0,0,0-.465-.343l-.279-.127h9.134a.965.965,0,0,0,.981-.79A.939.939,0,0,0,12.218,36.553Z" transform="translate(0 -31.842)" fill="#404156"/>
					</g>
				</svg> -->

				<a href="<?php echo home_url(); ?>">Back to home page</a>
			</div>
		</div>

		<div class="order-details-container billing col-sm-4 ">		
		<?php do_action( 'woocommerce_thankyou', $order->get_id() ); ?>
		</div>	


	<?php else : ?> 



		<p class="woocommerce-notice woocommerce-notice--success woocommerce-thankyou-order-received"><?php echo apply_filters( 'woocommerce_thankyou_order_received_text', __( "Thank you for placing your order. Your order has been received successfully. A passcode will be sent to your email for door access. In case you haven't received it, the passcode is <strong>'$passcodes'</strong>.", 'woocommerce' ), null ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?></p>



	<?php endif; ?>
		


</div>

